#ifndef __STM32F407_H__
#define __STM32F407_H__

#include <stdint.h>

#define MPU_TYPE (*(volatile uint32_t*)0xE000ED90)
#define MPU_CTRL (*(volatile uint32_t*)0xE000ED94)
#define MPU_RNR (*(volatile uint32_t*)0xE000ED98)
#define MPU_RBAR (*(volatile uint32_t*)0xE000ED9C)
#define MPU_RASR (*(volatile uint32_t*)0xE000EDA0)
#define MPU_RBAR_A1 (*(volatile uint32_t*)0xE000EDA4)
#define MPU_RASR_A1 (*(volatile uint32_t*)0xE000EDA8)
#define MPU_RBAR_A2 (*(volatile uint32_t*)0xE000EDAC)
#define MPU_RASR_A2 (*(volatile uint32_t*)0xE000EDB0)
#define MPU_RBAR_A3 (*(volatile uint32_t*)0xE000EDB4)
#define MPU_RASR_A3 (*(volatile uint32_t*)0xE000EDB8)
#define NVIC (*(volatile uint32_t*)0xE000E004)
#define SYSTICKCSR (*(volatile uint32_t*)0xE000E010)
#define SYSTICKRVR (*(volatile uint32_t*)0xE000E014)
#define SYSTICKCVR (*(volatile uint32_t*)0xE000E018)
#define SYSTICKCALVR (*(volatile uint32_t*)0xE000E01C)
#define NVIC_ISER0 (*(volatile uint32_t*)0xE000E100)
#define NVIC_ISER1 (*(volatile uint32_t*)0xE000E104)
#define NVIC_ISER2 (*(volatile uint32_t*)0xE000E108)
#define CLRENA0 (*(volatile uint32_t*)0xE000E180)
#define CLRENA1 (*(volatile uint32_t*)0xE000E184)
#define CLRENA2 (*(volatile uint32_t*)0xE000E188)
#define SETPEND0 (*(volatile uint32_t*)0xE000E200)
#define SETPEND1 (*(volatile uint32_t*)0xE000E204)
#define SETPEND2 (*(volatile uint32_t*)0xE000E208)
#define CLRPEND0 (*(volatile uint32_t*)0xE000E280)
#define CLRPEND1 (*(volatile uint32_t*)0xE000E284)
#define CLRPEND2 (*(volatile uint32_t*)0xE000E288)
#define ACTIVE0 (*(volatile uint32_t*)0xE000E300)
#define ACTIVE1 (*(volatile uint32_t*)0xE000E304)
#define ACTIVE2 (*(volatile uint32_t*)0xE000E308)
#define IP0 (*(volatile uint32_t*)0xE000E400)
#define IP1 (*(volatile uint32_t*)0xE000E404)
#define IP2 (*(volatile uint32_t*)0xE000E408)
#define IP3 (*(volatile uint32_t*)0xE000E40C)
#define IP4 (*(volatile uint32_t*)0xE000E410)
#define IP5 (*(volatile uint32_t*)0xE000E414)
#define IP6 (*(volatile uint32_t*)0xE000E418)
#define IP7 (*(volatile uint32_t*)0xE000E41C)
#define IP8 (*(volatile uint32_t*)0xE000E420)
#define IP9 (*(volatile uint32_t*)0xE000E424)
#define IP10 (*(volatile uint32_t*)0xE000E428)
#define IP11 (*(volatile uint32_t*)0xE000E42C)
#define IP12 (*(volatile uint32_t*)0xE000E430)
#define IP13 (*(volatile uint32_t*)0xE000E434)
#define IP14 (*(volatile uint32_t*)0xE000E438)
#define IP15 (*(volatile uint32_t*)0xE000E43C)
#define IP16 (*(volatile uint32_t*)0xE000E440)
#define IP17 (*(volatile uint32_t*)0xE000E444)
#define IP18 (*(volatile uint32_t*)0xE000E448)
#define IP19 (*(volatile uint32_t*)0xE000E44C)
#define CPUIDBR (*(volatile uint32_t*)0xE000ED00)
#define ICSR (*(volatile uint32_t*)0xE000ED04)
#define VTOR (*(volatile uint32_t*)0xE000ED08)
#define AIRCR (*(volatile uint32_t*)0xE000ED0C)
#define SCR (*(volatile uint32_t*)0xE000ED10)
#define CCR (*(volatile uint32_t*)0xE000ED14)
#define SHPR0 (*(volatile uint32_t*)0xE000ED18)
#define SHPR1 (*(volatile uint32_t*)0xE000ED1C)
#define SHPR2 (*(volatile uint32_t*)0xE000ED20)
#define SHCSR (*(volatile uint32_t*)0xE000ED24)
#define CFSR (*(volatile uint32_t*)0xE000ED28)
#define HFSR (*(volatile uint32_t*)0xE000ED2C)
#define DFSR (*(volatile uint32_t*)0xE000ED30)
#define MMFAR (*(volatile uint32_t*)0xE000ED34)
#define BFAR (*(volatile uint32_t*)0xE000ED38)
#define STIR (*(volatile uint32_t*)0xE000EF00)
#define DBGMCU_IDCODE (*(volatile uint32_t*)0xE0042000)
#define DBGMCU_CR (*(volatile uint32_t*)0xE0042004)
#define DBGMCU_APB1_FZ (*(volatile uint32_t*)0xE0042008)
#define DBGMCU_APB2_FZ (*(volatile uint32_t*)0xE004200C)
#define PWR_CR (*(volatile uint32_t*)0x40007000)
#define PWR_CSR (*(volatile uint32_t*)0x40007004)
#define RCC_CR (*(volatile uint32_t*)0x40023800)
#define RCC_PLLCFGR (*(volatile uint32_t*)0x40023804)
#define RCC_CFGR (*(volatile uint32_t*)0x40023808)
#define RCC_CIR (*(volatile uint32_t*)0x4002380C)
#define RCC_AHB1RSTR (*(volatile uint32_t*)0x40023810)
#define RCC_AHB2RSTR (*(volatile uint32_t*)0x40023814)
#define RCC_AHB3RSTR (*(volatile uint32_t*)0x40023818)
#define RCC_APB1RSTR (*(volatile uint32_t*)0x40023820)
#define RCC_APB2RSTR (*(volatile uint32_t*)0x40023824)
#define RCC_AHB1ENR (*(volatile uint32_t*)0x40023830)
#define RCC_AHB2ENR (*(volatile uint32_t*)0x40023834)
#define RCC_AHB3ENR (*(volatile uint32_t*)0x40023838)
#define RCC_APB1ENR (*(volatile uint32_t*)0x40023840)
#define RCC_APB2ENR (*(volatile uint32_t*)0x40023844)
#define RCC_AHB1LPENR (*(volatile uint32_t*)0x40023850)
#define RCC_AHB2LPENR (*(volatile uint32_t*)0x40023854)
#define RCC_AHB3LPENR (*(volatile uint32_t*)0x40023858)
#define RCC_APB1LPENR (*(volatile uint32_t*)0x40023860)
#define RCC_APB2LPENR (*(volatile uint32_t*)0x40023864)
#define RCC_BDCR (*(volatile uint32_t*)0x40023870)
#define RCC_CSR (*(volatile uint32_t*)0x40023874)
#define RCC_SSCGR (*(volatile uint32_t*)0x40023880)
#define RCC_PLLI2SCFGR (*(volatile uint32_t*)0x40023884)
#define GPIOA_MODER (*(volatile uint32_t*)0x40020000)
#define GPIOA_OTYPER (*(volatile uint32_t*)0x40020004)
#define GPIOA_OSPEEDR (*(volatile uint32_t*)0x40020008)
#define GPIOA_PUPDR (*(volatile uint32_t*)0x4002000C)
#define GPIOA_IDR (*(volatile uint32_t*)0x40020010)
#define GPIOA_ODR (*(volatile uint32_t*)0x40020014)
#define GPIOA_BSRR (*(volatile uint32_t*)0x40020018)
#define GPIOA_LCKR (*(volatile uint32_t*)0x4002001C)
#define GPIOA_AFRL (*(volatile uint32_t*)0x40020020)
#define GPIOA_AFRH (*(volatile uint32_t*)0x40020024)
#define GPIOB_MODER (*(volatile uint32_t*)0x40020400)
#define GPIOB_OTYPER (*(volatile uint32_t*)0x40020404)
#define GPIOB_OSPEEDR (*(volatile uint32_t*)0x40020408)
#define GPIOB_PUPDR (*(volatile uint32_t*)0x4002040C)
#define GPIOB_IDR (*(volatile uint32_t*)0x40020410)
#define GPIOB_ODR (*(volatile uint32_t*)0x40020414)
#define GPIOB_BSRR (*(volatile uint32_t*)0x40020418)
#define GPIOB_LCKR (*(volatile uint32_t*)0x4002041C)
#define GPIOB_AFRL (*(volatile uint32_t*)0x40020420)
#define GPIOB_AFRH (*(volatile uint32_t*)0x40020424)
#define GPIOC_MODER (*(volatile uint32_t*)0x40020800)
#define GPIOC_OTYPER (*(volatile uint32_t*)0x40020804)
#define GPIOC_OSPEEDR (*(volatile uint32_t*)0x40020808)
#define GPIOC_PUPDR (*(volatile uint32_t*)0x4002080C)
#define GPIOC_IDR (*(volatile uint32_t*)0x40020810)
#define GPIOC_ODR (*(volatile uint32_t*)0x40020814)
#define GPIOC_BSRR (*(volatile uint32_t*)0x40020818)
#define GPIOC_LCKR (*(volatile uint32_t*)0x4002081C)
#define GPIOC_AFRL (*(volatile uint32_t*)0x40020820)
#define GPIOC_AFRH (*(volatile uint32_t*)0x40020824)
#define GPIOD_MODER (*(volatile uint32_t*)0x40020C00)
#define GPIOD_OTYPER (*(volatile uint32_t*)0x40020C04)
#define GPIOD_OSPEEDR (*(volatile uint32_t*)0x40020C08)
#define GPIOD_PUPDR (*(volatile uint32_t*)0x40020C0C)
#define GPIOD_IDR (*(volatile uint32_t*)0x40020C10)
#define GPIOD_ODR (*(volatile uint32_t*)0x40020C14)
#define GPIOD_BSRR (*(volatile uint32_t*)0x40020C18)
#define GPIOD_LCKR (*(volatile uint32_t*)0x40020C1C)
#define GPIOD_AFRL (*(volatile uint32_t*)0x40020C20)
#define GPIOD_AFRH (*(volatile uint32_t*)0x40020C24)
#define GPIOE_MODER (*(volatile uint32_t*)0x40021000)
#define GPIOE_OTYPER (*(volatile uint32_t*)0x40021004)
#define GPIOE_OSPEEDR (*(volatile uint32_t*)0x40021008)
#define GPIOE_PUPDR (*(volatile uint32_t*)0x4002100C)
#define GPIOE_IDR (*(volatile uint32_t*)0x40021010)
#define GPIOE_ODR (*(volatile uint32_t*)0x40021014)
#define GPIOE_BSRR (*(volatile uint32_t*)0x40021018)
#define GPIOE_LCKR (*(volatile uint32_t*)0x4002101C)
#define GPIOE_AFRL (*(volatile uint32_t*)0x40021020)
#define GPIOE_AFRH (*(volatile uint32_t*)0x40021024)
#define GPIOH_MODER (*(volatile uint32_t*)0x40021C00)
#define GPIOH_OTYPER (*(volatile uint32_t*)0x40021C04)
#define GPIOH_OSPEEDR (*(volatile uint32_t*)0x40021C08)
#define GPIOH_PUPDR (*(volatile uint32_t*)0x40021C0C)
#define GPIOH_IDR (*(volatile uint32_t*)0x40021C10)
#define GPIOH_ODR (*(volatile uint32_t*)0x40021C14)
#define GPIOH_BSRR (*(volatile uint32_t*)0x40021C18)
#define GPIOH_LCKR (*(volatile uint32_t*)0x40021C1C)
#define GPIOH_AFRL (*(volatile uint32_t*)0x40021C20)
#define GPIOH_AFRH (*(volatile uint32_t*)0x40021C24)
#define SYSCFG_MEMRMP (*(volatile uint32_t*)0x40013800)
#define SYSCFG_PMC (*(volatile uint32_t*)0x40013804)
#define SYSCFG_EXTICR1 (*(volatile uint32_t*)0x40013808)
#define SYSCFG_EXTICR2 (*(volatile uint32_t*)0x4001380C)
#define SYSCFG_EXTICR3 (*(volatile uint32_t*)0x40013810)
#define SYSCFG_EXTICR4 (*(volatile uint32_t*)0x40013814)
#define SYSCFG_CMPCR (*(volatile uint32_t*)0x40013820)
#define EXTI_IMR (*(volatile uint32_t*)0x40013C00)
#define EXTI_EMR (*(volatile uint32_t*)0x40013C04)
#define EXTI_RTSR (*(volatile uint32_t*)0x40013C08)
#define EXTI_FTSR (*(volatile uint32_t*)0x40013C0C)
#define EXTI_SWIER (*(volatile uint32_t*)0x40013C10)
#define EXTI_PR (*(volatile uint32_t*)0x40013C14)
#define DMA1_LISR (*(volatile uint32_t*)0x40026000)
#define DMA1_HISR (*(volatile uint32_t*)0x40026004)
#define DMA1_LIFCR (*(volatile uint32_t*)0x40026008)
#define DMA1_HIFCR (*(volatile uint32_t*)0x4002600C)
#define DMA1_S0CR (*(volatile uint32_t*)0x40026010)
#define DMA1_S0NDTR (*(volatile uint32_t*)0x40026014)
#define DMA1_S0PAR (*(volatile uint32_t*)0x40026018)
#define DMA1_S0M0AR (*(volatile uint32_t*)0x4002601C)
#define DMA1_S0M1AR (*(volatile uint32_t*)0x40026020)
#define DMA1_S0FCR (*(volatile uint32_t*)0x40026024)
#define DMA1_S1CR (*(volatile uint32_t*)0x40026028)
#define DMA1_S1NDTR (*(volatile uint32_t*)0x4002602C)
#define DMA1_S1PAR (*(volatile uint32_t*)0x40026030)
#define DMA1_S1M0AR (*(volatile uint32_t*)0x40026034)
#define DMA1_S1M1AR (*(volatile uint32_t*)0x40026038)
#define DMA1_S1FCR (*(volatile uint32_t*)0x4002603C)
#define DMA1_S2CR (*(volatile uint32_t*)0x40026040)
#define DMA1_S2NDTR (*(volatile uint32_t*)0x40026044)
#define DMA1_S2PAR (*(volatile uint32_t*)0x40026048)
#define DMA1_S2M0AR (*(volatile uint32_t*)0x4002604C)
#define DMA1_S2M1AR (*(volatile uint32_t*)0x40026050)
#define DMA1_S2FCR (*(volatile uint32_t*)0x40026054)
#define DMA1_S3CR (*(volatile uint32_t*)0x40026058)
#define DMA1_S3NDTR (*(volatile uint32_t*)0x4002605C)
#define DMA1_S3PAR (*(volatile uint32_t*)0x40026060)
#define DMA1_S3M0AR (*(volatile uint32_t*)0x40026064)
#define DMA1_S3M1AR (*(volatile uint32_t*)0x40026068)
#define DMA1_S3FCR (*(volatile uint32_t*)0x4002606C)
#define DMA1_S4CR (*(volatile uint32_t*)0x40026070)
#define DMA1_S4NDTR (*(volatile uint32_t*)0x40026074)
#define DMA1_S4PAR (*(volatile uint32_t*)0x40026078)
#define DMA1_S4M0AR (*(volatile uint32_t*)0x4002607C)
#define DMA1_S4M1AR (*(volatile uint32_t*)0x40026080)
#define DMA1_S4FCR (*(volatile uint32_t*)0x40026084)
#define DMA1_S5CR (*(volatile uint32_t*)0x40026088)
#define DMA1_S5NDTR (*(volatile uint32_t*)0x4002608C)
#define DMA1_S5PAR (*(volatile uint32_t*)0x40026090)
#define DMA1_S5M0AR (*(volatile uint32_t*)0x40026094)
#define DMA1_S5M1AR (*(volatile uint32_t*)0x40026098)
#define DMA1_S5FCR (*(volatile uint32_t*)0x4002609C)
#define DMA1_S6CR (*(volatile uint32_t*)0x400260A0)
#define DMA1_S6NDTR (*(volatile uint32_t*)0x400260A4)
#define DMA1_S6PAR (*(volatile uint32_t*)0x400260A8)
#define DMA1_S6M0AR (*(volatile uint32_t*)0x400260AC)
#define DMA1_S6M1AR (*(volatile uint32_t*)0x400260B0)
#define DMA1_S6FCR (*(volatile uint32_t*)0x400260B4)
#define DMA1_S7CR (*(volatile uint32_t*)0x400260B8)
#define DMA1_S7NDTR (*(volatile uint32_t*)0x400260BC)
#define DMA1_S7PAR (*(volatile uint32_t*)0x400260C0)
#define DMA1_S7M0AR (*(volatile uint32_t*)0x400260C4)
#define DMA1_S7M1AR (*(volatile uint32_t*)0x400260C8)
#define DMA1_S7FCR (*(volatile uint32_t*)0x400260CC)
#define DMA2_LISR (*(volatile uint32_t*)0x40026400)
#define DMA2_HISR (*(volatile uint32_t*)0x40026404)
#define DMA2_LIFCR (*(volatile uint32_t*)0x40026408)
#define DMA2_HIFCR (*(volatile uint32_t*)0x4002640C)
#define DMA2_S0CR (*(volatile uint32_t*)0x40026410)
#define DMA2_S0NDTR (*(volatile uint32_t*)0x40026414)
#define DMA2_S0PAR (*(volatile uint32_t*)0x40026418)
#define DMA2_S0M0AR (*(volatile uint32_t*)0x4002641C)
#define DMA2_S0M1AR (*(volatile uint32_t*)0x40026420)
#define DMA2_S0FCR (*(volatile uint32_t*)0x40026424)
#define DMA2_S1CR (*(volatile uint32_t*)0x40026428)
#define DMA2_S1NDTR (*(volatile uint32_t*)0x4002642C)
#define DMA2_S1PAR (*(volatile uint32_t*)0x40026430)
#define DMA2_S1M0AR (*(volatile uint32_t*)0x40026434)
#define DMA2_S1M1AR (*(volatile uint32_t*)0x40026438)
#define DMA2_S1FCR (*(volatile uint32_t*)0x4002643C)
#define DMA2_S2CR (*(volatile uint32_t*)0x40026440)
#define DMA2_S2NDTR (*(volatile uint32_t*)0x40026444)
#define DMA2_S2PAR (*(volatile uint32_t*)0x40026448)
#define DMA2_S2M0AR (*(volatile uint32_t*)0x4002644C)
#define DMA2_S2M1AR (*(volatile uint32_t*)0x40026450)
#define DMA2_S2FCR (*(volatile uint32_t*)0x40026454)
#define DMA2_S3CR (*(volatile uint32_t*)0x40026458)
#define DMA2_S3NDTR (*(volatile uint32_t*)0x4002645C)
#define DMA2_S3PAR (*(volatile uint32_t*)0x40026460)
#define DMA2_S3M0AR (*(volatile uint32_t*)0x40026464)
#define DMA2_S3M1AR (*(volatile uint32_t*)0x40026468)
#define DMA2_S3FCR (*(volatile uint32_t*)0x4002646C)
#define DMA2_S4CR (*(volatile uint32_t*)0x40026470)
#define DMA2_S4NDTR (*(volatile uint32_t*)0x40026474)
#define DMA2_S4PAR (*(volatile uint32_t*)0x40026478)
#define DMA2_S4M0AR (*(volatile uint32_t*)0x4002647C)
#define DMA2_S4M1AR (*(volatile uint32_t*)0x40026480)
#define DMA2_S4FCR (*(volatile uint32_t*)0x40026484)
#define DMA2_S5CR (*(volatile uint32_t*)0x40026488)
#define DMA2_S5NDTR (*(volatile uint32_t*)0x4002648C)
#define DMA2_S5PAR (*(volatile uint32_t*)0x40026490)
#define DMA2_S5M0AR (*(volatile uint32_t*)0x40026494)
#define DMA2_S5M1AR (*(volatile uint32_t*)0x40026498)
#define DMA2_S5FCR (*(volatile uint32_t*)0x4002649C)
#define DMA2_S6CR (*(volatile uint32_t*)0x400264A0)
#define DMA2_S6NDTR (*(volatile uint32_t*)0x400264A4)
#define DMA2_S6PAR (*(volatile uint32_t*)0x400264A8)
#define DMA2_S6M0AR (*(volatile uint32_t*)0x400264AC)
#define DMA2_S6M1AR (*(volatile uint32_t*)0x400264B0)
#define DMA2_S6FCR (*(volatile uint32_t*)0x400264B4)
#define DMA2_S7CR (*(volatile uint32_t*)0x400264B8)
#define DMA2_S7NDTR (*(volatile uint32_t*)0x400264BC)
#define DMA2_S7PAR (*(volatile uint32_t*)0x400264C0)
#define DMA2_S7M0AR (*(volatile uint32_t*)0x400264C4)
#define DMA2_S7M1AR (*(volatile uint32_t*)0x400264C8)
#define DMA2_S7FCR (*(volatile uint32_t*)0x400264CC)
#define RTC_TR (*(volatile uint32_t*)0x40002800)
#define RTC_DR (*(volatile uint32_t*)0x40002804)
#define RTC_CR (*(volatile uint32_t*)0x40002808)
#define RTC_ISR (*(volatile uint32_t*)0x4000280C)
#define RTC_PRER (*(volatile uint32_t*)0x40002810)
#define RTC_WUTR (*(volatile uint32_t*)0x40002814)
#define RTC_CALIBR (*(volatile uint32_t*)0x40002818)
#define RTC_ALRMAR (*(volatile uint32_t*)0x4000281C)
#define RTC_ALRMBR (*(volatile uint32_t*)0x40002820)
#define RTC_WPR (*(volatile uint32_t*)0x40002824)
#define RTC_TSTR (*(volatile uint32_t*)0x40002830)
#define RTC_TSDR (*(volatile uint32_t*)0x40002834)
#define RTC_TAFCR (*(volatile uint32_t*)0x40002840)
#define RTC_BK0R (*(volatile uint32_t*)0x40002850)
#define RTC_BK1R (*(volatile uint32_t*)0x40002854)
#define RTC_BK2R (*(volatile uint32_t*)0x40002858)
#define RTC_BK3R (*(volatile uint32_t*)0x4000285C)
#define RTC_BK4R (*(volatile uint32_t*)0x40002860)
#define RTC_BK5R (*(volatile uint32_t*)0x40002864)
#define RTC_BK6R (*(volatile uint32_t*)0x40002868)
#define RTC_BK7R (*(volatile uint32_t*)0x4000286C)
#define RTC_BK8R (*(volatile uint32_t*)0x40002870)
#define RTC_BK9R (*(volatile uint32_t*)0x40002874)
#define RTC_BK10R (*(volatile uint32_t*)0x40002878)
#define RTC_BK11R (*(volatile uint32_t*)0x4000287C)
#define RTC_BK12R (*(volatile uint32_t*)0x40002880)
#define RTC_BK13R (*(volatile uint32_t*)0x40002884)
#define RTC_BK14R (*(volatile uint32_t*)0x40002888)
#define RTC_BK15R (*(volatile uint32_t*)0x4000288C)
#define RTC_BK16R (*(volatile uint32_t*)0x40002890)
#define RTC_BK17R (*(volatile uint32_t*)0x40002894)
#define RTC_BK18R (*(volatile uint32_t*)0x40002898)
#define RTC_BK19R (*(volatile uint32_t*)0x4000289C)
#define IWDG_KR (*(volatile uint16_t*)0x40003000)
#define IWDG_PR (*(volatile uint16_t*)0x40003004)
#define IWDG_RLR (*(volatile uint16_t*)0x40003008)
#define IWDG_SR (*(volatile uint16_t*)0x4000300C)
#define WWDG_CR (*(volatile uint16_t*)0x40002C00)
#define WWDG_CFR (*(volatile uint16_t*)0x40002C04)
#define WWDG_SR (*(volatile uint16_t*)0x40002C08)
#define RNG_CR (*(volatile uint32_t*)0x50060800)
#define RNG_SR (*(volatile uint32_t*)0x50060804)
#define RNG_DR (*(volatile uint32_t*)0x50060808)
#define TIM1_CR1 (*(volatile uint32_t*)0x40010000)
#define TIM1_CR2 (*(volatile uint32_t*)0x40010004)
#define TIM1_SMCR (*(volatile uint32_t*)0x40010008)
#define TIM1_DIER (*(volatile uint32_t*)0x4001000C)
#define TIM1_SR (*(volatile uint32_t*)0x40010010)
#define TIM1_EGR (*(volatile uint32_t*)0x40010014)
#define TIM1_CCMR1 (*(volatile uint32_t*)0x40010018)
#define TIM1_OCMR1      TIM1_CCMR1
#define TIM1_CCMR2 (*(volatile uint32_t*)0x4001001C)
#define TIM1_OCMR2      TIM1_CCMR2
#define TIM1_CCER (*(volatile uint32_t*)0x40010020)
#define TIM1_CNT (*(volatile uint32_t*)0x40010024)
#define TIM1_PSC (*(volatile uint32_t*)0x40010028)
#define TIM1_ARR (*(volatile uint32_t*)0x4001002C)
#define TIM1_RCR (*(volatile uint32_t*)0x40010030)
#define TIM1_CCR1 (*(volatile uint32_t*)0x40010034)
#define TIM1_CCR2 (*(volatile uint32_t*)0x40010038)
#define TIM1_CCR3 (*(volatile uint32_t*)0x4001003C)
#define TIM1_CCR4 (*(volatile uint32_t*)0x40010040)
#define TIM1_BDTR (*(volatile uint32_t*)0x40010044)
#define TIM1_DCR (*(volatile uint32_t*)0x40010048)
#define TIM1_DMAR (*(volatile uint32_t*)0x4001004C)
#define TIM8_CR1 (*(volatile uint32_t*)0x40010400)
#define TIM8_CR2 (*(volatile uint32_t*)0x40010404)
#define TIM8_SMCR (*(volatile uint32_t*)0x40010408)
#define TIM8_DIER (*(volatile uint32_t*)0x4001040C)
#define TIM8_SR (*(volatile uint32_t*)0x40010410)
#define TIM8_EGR (*(volatile uint32_t*)0x40010414)
#define TIM8_CCMR1 (*(volatile uint32_t*)0x40010418)
#define TIM8_OCMR1      TIM8_CCMR1
#define TIM8_CCMR2 (*(volatile uint32_t*)0x4001041C)
#define TIM8_OCMR2      TIM8_CCMR2
#define TIM8_CCER (*(volatile uint32_t*)0x40010420)
#define TIM8_CNT (*(volatile uint32_t*)0x40010424)
#define TIM8_PSC (*(volatile uint32_t*)0x40010428)
#define TIM8_ARR (*(volatile uint32_t*)0x4001042C)
#define TIM8_RCR (*(volatile uint32_t*)0x40010430)
#define TIM8_CCR1 (*(volatile uint32_t*)0x40010434)
#define TIM8_CCR2 (*(volatile uint32_t*)0x40010438)
#define TIM8_CCR3 (*(volatile uint32_t*)0x4001043C)
#define TIM8_CCR4 (*(volatile uint32_t*)0x40010440)
#define TIM8_BDTR (*(volatile uint32_t*)0x40010444)
#define TIM8_DCR (*(volatile uint32_t*)0x40010448)
#define TIM8_DMAR (*(volatile uint32_t*)0x4001044C)
#define TIM2_CR1 (*(volatile uint32_t*)0x40000000)
#define TIM2_CR2 (*(volatile uint32_t*)0x40000004)
#define TIM2_SMCR (*(volatile uint32_t*)0x40000008)
#define TIM2_DIER (*(volatile uint32_t*)0x4000000C)
#define TIM2_SR (*(volatile uint32_t*)0x40000010)
#define TIM2_EGR (*(volatile uint32_t*)0x40000014)
#define TIM2_CCMR1 (*(volatile uint32_t*)0x40000018)
#define TIM2_OCMR1      TIM2_CCMR1
#define TIM2_CCMR2 (*(volatile uint32_t*)0x4000001C)
#define TIM2_OCMR2      TIM2_CCMR2
#define TIM2_CCER (*(volatile uint32_t*)0x40000020)
#define TIM2_CNT (*(volatile uint32_t*)0x40000024)
#define TIM2_PSC (*(volatile uint32_t*)0x40000028)
#define TIM2_ARR (*(volatile uint32_t*)0x4000002C)
#define TIM2_CCR1 (*(volatile uint32_t*)0x40000034)
#define TIM2_CCR2 (*(volatile uint32_t*)0x40000038)
#define TIM2_CCR3 (*(volatile uint32_t*)0x4000003C)
#define TIM2_CCR4 (*(volatile uint32_t*)0x40000040)
#define TIM2_DCR (*(volatile uint32_t*)0x40000048)
#define TIM2_DMAR (*(volatile uint32_t*)0x4000004C)
#define TIM2_OR (*(volatile uint32_t*)0x40000050)
#define TIM3_CR1 (*(volatile uint32_t*)0x40000400)
#define TIM3_CR2 (*(volatile uint32_t*)0x40000404)
#define TIM3_SMCR (*(volatile uint32_t*)0x40000408)
#define TIM3_DIER (*(volatile uint32_t*)0x4000040C)
#define TIM3_SR (*(volatile uint32_t*)0x40000410)
#define TIM3_EGR (*(volatile uint32_t*)0x40000414)
#define TIM3_CCMR1 (*(volatile uint32_t*)0x40000418)
#define TIM3_OCMR1      TIM3_CCMR1
#define TIM3_CCMR2 (*(volatile uint32_t*)0x4000041C)
#define TIM3_OCMR2      TIM3_CCMR2
#define TIM3_CCER (*(volatile uint32_t*)0x40000420)
#define TIM3_CNT (*(volatile uint32_t*)0x40000424)
#define TIM3_PSC (*(volatile uint32_t*)0x40000428)
#define TIM3_ARR (*(volatile uint32_t*)0x4000042C)
#define TIM3_CCR1 (*(volatile uint32_t*)0x40000434)
#define TIM3_CCR2 (*(volatile uint32_t*)0x40000438)
#define TIM3_DCR (*(volatile uint32_t*)0x40000448)
#define TIM3_DMAR (*(volatile uint32_t*)0x4000044C)
#define TIM4_CR1 (*(volatile uint32_t*)0x40000800)
#define TIM4_CR2 (*(volatile uint32_t*)0x40000804)
#define TIM4_SMCR (*(volatile uint32_t*)0x40000808)
#define TIM4_DIER (*(volatile uint32_t*)0x4000080C)
#define TIM4_SR (*(volatile uint32_t*)0x40000810)
#define TIM4_EGR (*(volatile uint32_t*)0x40000814)
#define TIM4_CCMR1 (*(volatile uint32_t*)0x40000818)
#define TIM4_OCMR1      TIM4_CCMR1
#define TIM4_CCMR2 (*(volatile uint32_t*)0x4000081C)
#define TIM4_OCMR2      TIM4_CCMR2
#define TIM4_CCER (*(volatile uint32_t*)0x40000820)
#define TIM4_CNT (*(volatile uint32_t*)0x40000824)
#define TIM4_PSC (*(volatile uint32_t*)0x40000828)
#define TIM4_ARR (*(volatile uint32_t*)0x4000082C)
#define TIM4_CCR1 (*(volatile uint32_t*)0x40000834)
#define TIM4_CCR2 (*(volatile uint32_t*)0x40000838)
#define TIM4_DCR (*(volatile uint32_t*)0x40000848)
#define TIM4_DMAR (*(volatile uint32_t*)0x4000084C)
#define TIM5_CR1 (*(volatile uint32_t*)0x40000C00)
#define TIM5_CR2 (*(volatile uint32_t*)0x40000C04)
#define TIM5_SMCR (*(volatile uint32_t*)0x40000C08)
#define TIM5_DIER (*(volatile uint32_t*)0x40000C0C)
#define TIM5_SR (*(volatile uint32_t*)0x40000C10)
#define TIM5_EGR (*(volatile uint32_t*)0x40000C14)
#define TIM5_CCMR1 (*(volatile uint32_t*)0x40000C18)
#define TIM5_OCMR1      TIM5_CCMR1
#define TIM5_CCMR2 (*(volatile uint32_t*)0x40000C1C)
#define TIM5_OCMR2      TIM5_CCMR2
#define TIM5_CCER (*(volatile uint32_t*)0x40000C20)
#define TIM5_CNT (*(volatile uint32_t*)0x40000C24)
#define TIM5_PSC (*(volatile uint32_t*)0x40000C28)
#define TIM5_ARR (*(volatile uint32_t*)0x40000C2C)
#define TIM5_CCR1 (*(volatile uint32_t*)0x40000C34)
#define TIM5_CCR2 (*(volatile uint32_t*)0x40000C38)
#define TIM5_CCR3 (*(volatile uint32_t*)0x40000C3C)
#define TIM5_CCR4 (*(volatile uint32_t*)0x40000C40)
#define TIM5_DCR (*(volatile uint32_t*)0x40000C48)
#define TIM5_DMAR (*(volatile uint32_t*)0x40000C4C)
#define TIM5_OR (*(volatile uint32_t*)0x40000C50)
#define TIM6_CR1 (*(volatile uint32_t*)0x40001000)
#define TIM6_CR2 (*(volatile uint32_t*)0x40001004)
#define TIM6_DIER (*(volatile uint32_t*)0x4000100C)
#define TIM6_SR (*(volatile uint32_t*)0x40001010)
#define TIM6_EGR (*(volatile uint32_t*)0x40001014)
#define TIM6_CNT (*(volatile uint32_t*)0x40001024)
#define TIM6_PSC (*(volatile uint32_t*)0x40001028)
#define TIM6_ARR (*(volatile uint32_t*)0x4000102C)
#define TIM7_CR1 (*(volatile uint32_t*)0x40001400)
#define TIM7_CR2 (*(volatile uint32_t*)0x40001404)
#define TIM7_DIER (*(volatile uint32_t*)0x4000140C)
#define TIM7_SR (*(volatile uint32_t*)0x40001410)
#define TIM7_EGR (*(volatile uint32_t*)0x40001414)
#define TIM7_CNT (*(volatile uint32_t*)0x40001424)
#define TIM7_PSC (*(volatile uint32_t*)0x40001428)
#define TIM7_ARR (*(volatile uint32_t*)0x4000142C)
#define TIM9_CR1 (*(volatile uint32_t*)0x40014000)
#define TIM9_CR2 (*(volatile uint32_t*)0x40014004)
#define TIM9_SMCR (*(volatile uint32_t*)0x40014008)
#define TIM9_DIER (*(volatile uint32_t*)0x4001400C)
#define TIM9_SR (*(volatile uint32_t*)0x40014010)
#define TIM9_EGR (*(volatile uint32_t*)0x40014014)
#define TIM9_CCMR1 (*(volatile uint32_t*)0x40014018)
#define TIM9_OCMR1      TIM9_CCMR1
#define TIM9_CCER (*(volatile uint32_t*)0x40014020)
#define TIM9_CNT (*(volatile uint32_t*)0x40014024)
#define TIM9_PSC (*(volatile uint32_t*)0x40014028)
#define TIM9_ARR (*(volatile uint32_t*)0x4001402C)
#define TIM9_CCR1 (*(volatile uint32_t*)0x40014034)
#define TIM9_CCR2 (*(volatile uint32_t*)0x40014038)
#define TIM12_CR1 (*(volatile uint32_t*)0x40001800)
#define TIM12_CR2 (*(volatile uint32_t*)0x40001804)
#define TIM12_SMCR (*(volatile uint32_t*)0x40001808)
#define TIM12_DIER (*(volatile uint32_t*)0x4000180C)
#define TIM12_SR (*(volatile uint32_t*)0x40001810)
#define TIM12_EGR (*(volatile uint32_t*)0x40001814)
#define TIM12_CCMR1 (*(volatile uint32_t*)0x40001818)
#define TIM12_OCMR1      TIM12_CCMR1
#define TIM12_CCER (*(volatile uint32_t*)0x40001820)
#define TIM12_CNT (*(volatile uint32_t*)0x40001824)
#define TIM12_PSC (*(volatile uint32_t*)0x40001828)
#define TIM12_ARR (*(volatile uint32_t*)0x4000182C)
#define TIM12_CCR1 (*(volatile uint32_t*)0x40001834)
#define TIM12_CCR2 (*(volatile uint32_t*)0x40001838)
#define TIM10_CR1 (*(volatile uint32_t*)0x40014400)
#define TIM10_DIER (*(volatile uint32_t*)0x4001440C)
#define TIM10_SR (*(volatile uint32_t*)0x40014410)
#define TIM10_EGR (*(volatile uint32_t*)0x40014414)
#define TIM10_CCMR1 (*(volatile uint32_t*)0x40014418)
#define TIM10_OCMR1      TIM10_CCMR1
#define TIM10_CCER (*(volatile uint32_t*)0x40014420)
#define TIM10_CNT (*(volatile uint32_t*)0x40014424)
#define TIM10_PSC (*(volatile uint32_t*)0x40014428)
#define TIM10_ARR (*(volatile uint32_t*)0x4001442C)
#define TIM10_CCR1 (*(volatile uint32_t*)0x40014434)
#define TIM11_CR1 (*(volatile uint32_t*)0x40014800)
#define TIM11_DIER (*(volatile uint32_t*)0x4001480C)
#define TIM11_SR (*(volatile uint32_t*)0x40014810)
#define TIM11_EGR (*(volatile uint32_t*)0x40014814)
#define TIM11_CCMR1 (*(volatile uint32_t*)0x40014818)
#define TIM11_OCMR1      TIM11_CCMR1
#define TIM11_CCER (*(volatile uint32_t*)0x40014820)
#define TIM11_CNT (*(volatile uint32_t*)0x40014824)
#define TIM11_PSC (*(volatile uint32_t*)0x40014828)
#define TIM11_ARR (*(volatile uint32_t*)0x4001482C)
#define TIM11_CCR1 (*(volatile uint32_t*)0x40014834)
#define TIM11_OR (*(volatile uint32_t*)0x40014850)
#define TIM13_CR1 (*(volatile uint32_t*)0x40001C00)
#define TIM13_DIER (*(volatile uint32_t*)0x40001C0C)
#define TIM13_SR (*(volatile uint32_t*)0x40001C10)
#define TIM13_EGR (*(volatile uint32_t*)0x40001C14)
#define TIM13_CCMR1 (*(volatile uint32_t*)0x40001C18)
#define TIM13_OCMR1      TIM13_CCMR1
#define TIM13_CCER (*(volatile uint32_t*)0x40001C20)
#define TIM13_CNT (*(volatile uint32_t*)0x40001C24)
#define TIM13_PSC (*(volatile uint32_t*)0x40001C28)
#define TIM13_ARR (*(volatile uint32_t*)0x40001C2C)
#define TIM13_CCR1 (*(volatile uint32_t*)0x40001C34)
#define TIM14_CR1 (*(volatile uint32_t*)0x40002000)
#define TIM14_DIER (*(volatile uint32_t*)0x4000200C)
#define TIM14_SR (*(volatile uint32_t*)0x40002010)
#define TIM14_EGR (*(volatile uint32_t*)0x40002014)
#define TIM14_CCMR1 (*(volatile uint32_t*)0x40002018)
#define TIM14_OCMR1      TIM14_CCMR1
#define TIM14_CCER (*(volatile uint32_t*)0x40002020)
#define TIM14_CNT (*(volatile uint32_t*)0x40002024)
#define TIM14_PSC (*(volatile uint32_t*)0x40002028)
#define TIM14_ARR (*(volatile uint32_t*)0x4000202C)
#define TIM14_CCR1 (*(volatile uint32_t*)0x40002034)
#define CAN1_MCR (*(volatile uint32_t*)0x40006400)
#define CAN1_MSR (*(volatile uint32_t*)0x40006404)
#define CAN1_TSR (*(volatile uint32_t*)0x40006408)
#define CAN1_RF0R (*(volatile uint32_t*)0x4000640C)
#define CAN1_RF1R (*(volatile uint32_t*)0x40006410)
#define CAN1_IER (*(volatile uint32_t*)0x40006414)
#define CAN1_ESR (*(volatile uint32_t*)0x40006418)
#define CAN1_BTR (*(volatile uint32_t*)0x4000641C)
#define CAN1_TI0R (*(volatile uint32_t*)0x40006580)
#define CAN1_TDT0R (*(volatile uint32_t*)0x40006584)
#define CAN1_TDL0R (*(volatile uint32_t*)0x40006588)
#define CAN1_TDH0R (*(volatile uint32_t*)0x4000658c)
#define CAN1_TI1R (*(volatile uint32_t*)0x40006590)
#define CAN1_TDT1R (*(volatile uint32_t*)0x40006594)
#define CAN1_TDL1R (*(volatile uint32_t*)0x40006598)
#define CAN1_TDH1R (*(volatile uint32_t*)0x4000659C)
#define CAN1_TI2R (*(volatile uint32_t*)0x400065A0)
#define CAN1_TDT2R (*(volatile uint32_t*)0x400065A4)
#define CAN1_TDL2R (*(volatile uint32_t*)0x400065A8)
#define CAN1_TDH2R (*(volatile uint32_t*)0x400065AC)
#define CAN1_RI0R (*(volatile uint32_t*)0x400065B0)
#define CAN1_RDT0R (*(volatile uint32_t*)0x400065B4)
#define CAN1_RDL0R (*(volatile uint32_t*)0x400065B8)
#define CAN1_RDH0R (*(volatile uint32_t*)0x400065BC)
#define CAN1_RI1R (*(volatile uint32_t*)0x400065C0)
#define CAN1_RDT1R (*(volatile uint32_t*)0x400065C4)
#define CAN1_RDL1R (*(volatile uint32_t*)0x400065C8)
#define CAN1_RDH1R (*(volatile uint32_t*)0x400065CC)
#define CAN2_MCR (*(volatile uint32_t*)0x40006800)
#define CAN2_MSR (*(volatile uint32_t*)0x40006804)
#define CAN2_TSR (*(volatile uint32_t*)0x40006808)
#define CAN2_RF0R (*(volatile uint32_t*)0x4000680C)
#define CAN2_RF1R (*(volatile uint32_t*)0x40006810)
#define CAN2_IER (*(volatile uint32_t*)0x40006814)
#define CAN2_ESR (*(volatile uint32_t*)0x40006818)
#define CAN2_BTR (*(volatile uint32_t*)0x4000681C)
#define CAN2_TI0R (*(volatile uint32_t*)0x40006980)
#define CAN2_TDT0R (*(volatile uint32_t*)0x40006984)
#define CAN2_TDL0R (*(volatile uint32_t*)0x40006988)
#define CAN2_TDH0R (*(volatile uint32_t*)0x4000698c)
#define CAN2_TI1R (*(volatile uint32_t*)0x40006990)
#define CAN2_TDT1R (*(volatile uint32_t*)0x40006994)
#define CAN2_TDL1R (*(volatile uint32_t*)0x40006998)
#define CAN2_TDH1R (*(volatile uint32_t*)0x4000699C)
#define CAN2_TI2R (*(volatile uint32_t*)0x400069A0)
#define CAN2_TDT2R (*(volatile uint32_t*)0x400069A4)
#define CAN2_TDL2R (*(volatile uint32_t*)0x400069A8)
#define CAN2_TDH2R (*(volatile uint32_t*)0x400069AC)
#define CAN2_RI0R (*(volatile uint32_t*)0x400069B0)
#define CAN2_RDT0R (*(volatile uint32_t*)0x400069B4)
#define CAN2_RDL0R (*(volatile uint32_t*)0x400069B8)
#define CAN2_RDH0R (*(volatile uint32_t*)0x400069BC)
#define CAN2_RI1R (*(volatile uint32_t*)0x400069C0)
#define CAN2_RDT1R (*(volatile uint32_t*)0x400069C4)
#define CAN2_RDL1R (*(volatile uint32_t*)0x400069C8)
#define CAN2_RDH1R (*(volatile uint32_t*)0x400069CC)
#define CAN_FMR (*(volatile uint32_t*)0x40006600)
#define CAN_FM1R (*(volatile uint32_t*)0x40006604)
#define CAN_FS1R (*(volatile uint32_t*)0x4000660C)
#define CAN_FFA1R (*(volatile uint32_t*)0x40006614)
#define CAN_FA1R (*(volatile uint32_t*)0x4000661C)
#define CAN_F0R1 (*(volatile uint32_t*)0x40006640)
#define CAN_F0R2 (*(volatile uint32_t*)0x40006644)
#define CAN_F1R1 (*(volatile uint32_t*)0x40006648)
#define CAN_F1R2 (*(volatile uint32_t*)0x4000664C)
#define CAN_F2R1 (*(volatile uint32_t*)0x40006650)
#define CAN_F2R2 (*(volatile uint32_t*)0x40006654)
#define CAN_F3R1 (*(volatile uint32_t*)0x40006658)
#define CAN_F3R2 (*(volatile uint32_t*)0x4000665C)
#define CAN_F4R1 (*(volatile uint32_t*)0x40006660)
#define CAN_F4R2 (*(volatile uint32_t*)0x40006664)
#define CAN_F5R1 (*(volatile uint32_t*)0x40006668)
#define CAN_F5R2 (*(volatile uint32_t*)0x4000666C)
#define CAN_F6R1 (*(volatile uint32_t*)0x40006670)
#define CAN_F6R2 (*(volatile uint32_t*)0x40006674)
#define CAN_F7R1 (*(volatile uint32_t*)0x40006678)
#define CAN_F7R2 (*(volatile uint32_t*)0x4000667C)
#define CAN_F8R1 (*(volatile uint32_t*)0x40006680)
#define CAN_F8R2 (*(volatile uint32_t*)0x40006684)
#define CAN_F9R1 (*(volatile uint32_t*)0x40006688)
#define CAN_F9R2 (*(volatile uint32_t*)0x4000668C)
#define CAN_F10R1 (*(volatile uint32_t*)0x40006690)
#define CAN_F10R2 (*(volatile uint32_t*)0x40006694)
#define CAN_F11R1 (*(volatile uint32_t*)0x40006698)
#define CAN_F11R2 (*(volatile uint32_t*)0x4000669C)
#define CAN_F12R1 (*(volatile uint32_t*)0x400066A0)
#define CAN_F12R2 (*(volatile uint32_t*)0x400066A4)
#define CAN_F13R1 (*(volatile uint32_t*)0x400066A8)
#define CAN_F13R2 (*(volatile uint32_t*)0x400066AC)
#define CAN_F14R1 (*(volatile uint32_t*)0x400066B0)
#define CAN_F14R2 (*(volatile uint32_t*)0x400066B4)
#define CAN_F15R1 (*(volatile uint32_t*)0x400066B8)
#define CAN_F15R2 (*(volatile uint32_t*)0x400066BC)
#define CAN_F16R1 (*(volatile uint32_t*)0x400066C0)
#define CAN_F16R2 (*(volatile uint32_t*)0x400066C4)
#define CAN_F17R1 (*(volatile uint32_t*)0x400066c8)
#define CAN_F17R2 (*(volatile uint32_t*)0x400066CC)
#define CAN_F18R1 (*(volatile uint32_t*)0x400066D0)
#define CAN_F18R2 (*(volatile uint32_t*)0x400066D4)
#define CAN_F19R1 (*(volatile uint32_t*)0x400066D8)
#define CAN_F19R2 (*(volatile uint32_t*)0x400066DC)
#define CAN_F20R1 (*(volatile uint32_t*)0x400066E0)
#define CAN_F20R2 (*(volatile uint32_t*)0x400066E4)
#define CAN_F21R1 (*(volatile uint32_t*)0x400066E8)
#define CAN_F21R2 (*(volatile uint32_t*)0x400066EC)
#define CAN_F22R1 (*(volatile uint32_t*)0x400066F0)
#define CAN_F22R2 (*(volatile uint32_t*)0x400066F4)
#define CAN_F23R1 (*(volatile uint32_t*)0x400066F8)
#define CAN_F23R2 (*(volatile uint32_t*)0x400066FC)
#define CAN_F24R1 (*(volatile uint32_t*)0x40006700)
#define CAN_F24R2 (*(volatile uint32_t*)0x40006704)
#define CAN_F25R1 (*(volatile uint32_t*)0x40006708)
#define CAN_F25R2 (*(volatile uint32_t*)0x4000670C)
#define CAN_F26R1 (*(volatile uint32_t*)0x40006710)
#define CAN_F26R2 (*(volatile uint32_t*)0x40006714)
#define CAN_F27R1 (*(volatile uint32_t*)0x40006718)
#define CAN_F27R2 (*(volatile uint32_t*)0x4000671C)
#define I2C1_CR1 (*(volatile uint32_t*)0x40005400)
#define I2C1_CR2 (*(volatile uint32_t*)0x40005404)
#define I2C1_OAR1 (*(volatile uint32_t*)0x40005408)
#define I2C1_OAR2 (*(volatile uint32_t*)0x4000540C)
#define I2C1_DR (*(volatile uint32_t*)0x40005410)
#define I2C1_SR1 (*(volatile uint32_t*)0x40005414)
#define I2C1_SR2 (*(volatile uint32_t*)0x40005418)
#define I2C1_CCR (*(volatile uint32_t*)0x4000541C)
#define I2C1_TRISE (*(volatile uint32_t*)0x40005420)
#define I2C2_CR1 (*(volatile uint32_t*)0x40005800)
#define I2C2_CR2 (*(volatile uint32_t*)0x40005804)
#define I2C2_OAR1 (*(volatile uint32_t*)0x40005808)
#define I2C2_OAR2 (*(volatile uint32_t*)0x4000580C)
#define I2C2_DR (*(volatile uint32_t*)0x40005810)
#define I2C2_SR1 (*(volatile uint32_t*)0x40005814)
#define I2C2_SR2 (*(volatile uint32_t*)0x40005818)
#define I2C2_CCR (*(volatile uint32_t*)0x4000581C)
#define I2C2_TRISE (*(volatile uint32_t*)0x40005820)
#define I2C3_CR1 (*(volatile uint32_t*)0x40005C00)
#define I2C3_CR2 (*(volatile uint32_t*)0x40005C04)
#define I2C3_OAR1 (*(volatile uint32_t*)0x40005C08)
#define I2C3_OAR2 (*(volatile uint32_t*)0x40005C0C)
#define I2C3_DR (*(volatile uint32_t*)0x40005C10)
#define I2C3_SR1 (*(volatile uint32_t*)0x40005C14)
#define I2C3_SR2 (*(volatile uint32_t*)0x40005C18)
#define I2C3_CCR (*(volatile uint32_t*)0x40005C1C)
#define I2C3_TRISE (*(volatile uint32_t*)0x40005C20)
#define SPI1_CR1 (*(volatile uint32_t*)0x40013000)
#define SPI1_CR2 (*(volatile uint32_t*)0x40013004)
#define SPI1_SR (*(volatile uint32_t*)0x40013008)
#define SPI1_DR (*(volatile uint32_t*)0x4001300C)
#define SPI1_CRCPR (*(volatile uint32_t*)0x40013010)
#define SPI1_RXCRCR (*(volatile uint32_t*)0x40013014)
#define SPI1_TXCRCR (*(volatile uint32_t*)0x40013018)
#define SPI2_CR1 (*(volatile uint32_t*)0x40003800)
#define SPI2_CR2 (*(volatile uint32_t*)0x40003804)
#define SPI2_SR (*(volatile uint32_t*)0x40003808)
#define SPI2_DR (*(volatile uint32_t*)0x4000380C)
#define SPI2_CRCPR (*(volatile uint32_t*)0x40003810)
#define SPI2_RXCRCR (*(volatile uint32_t*)0x40003814)
#define SPI2_TXCRCR (*(volatile uint32_t*)0x40003818)
#define SPI2_I2SCFGR (*(volatile uint32_t*)0x4000381C)
#define SPI2_I2SPR (*(volatile uint32_t*)0x40003820)
#define SPI3_CR1 (*(volatile uint32_t*)0x40003C00)
#define SPI3_CR2 (*(volatile uint32_t*)0x40003C04)
#define SPI3_SR (*(volatile uint32_t*)0x40003C08)
#define SPI3_DR (*(volatile uint32_t*)0x40003C0C)
#define SPI3_CRCPR (*(volatile uint32_t*)0x40003C10)
#define SPI3_RXCRCR (*(volatile uint32_t*)0x40003C14)
#define SPI3_TXCRCR (*(volatile uint32_t*)0x40003C18)
#define SPI3_I2SCFGR (*(volatile uint32_t*)0x40003C1C)
#define SPI3_I2SPR (*(volatile uint32_t*)0x40003C20)
#define SDIO_POWER (*(volatile uint32_t*)0x40012C00)
#define SDIO_CLKCR (*(volatile uint32_t*)0x40012C04)
#define SDIO_ARG (*(volatile uint32_t*)0x40012C08)
#define SDIO_CMD (*(volatile uint32_t*)0x40012C0C)
#define SDIO_RESPCMD (*(volatile uint32_t*)0x40012C10)
#define SDIO_RESP1 (*(volatile uint32_t*)0x40012C14)
#define SDIO_RESP2 (*(volatile uint32_t*)0x40012C18)
#define SDIO_RESP3 (*(volatile uint32_t*)0x40012C1C)
#define SDIO_RESP4 (*(volatile uint32_t*)0x40012C20)
#define SDIO_DTIMER (*(volatile uint32_t*)0x40012C24)
#define SDIO_DLEN (*(volatile uint32_t*)0x40012C28)
#define SDIO_DCTRL (*(volatile uint32_t*)0x40012C2C)
#define SDIO_DCOUNT (*(volatile uint32_t*)0x40012C30)
#define SDIO_STA (*(volatile uint32_t*)0x40012C34)
#define SDIO_ICR (*(volatile uint32_t*)0x40012C38)
#define SDIO_MASK (*(volatile uint32_t*)0x40012C3C)
#define SDIO_FIFOCNT (*(volatile uint32_t*)0x40012C48)
#define SDIO_FIFO (*(volatile uint32_t*)0x40012C80)
#define USART1_SR (*(volatile uint32_t*)0x40011000)
#define USART1_DR (*(volatile uint32_t*)0x40011004)
#define USART1_BRR (*(volatile uint32_t*)0x40011008)
#define USART1_CR1 (*(volatile uint32_t*)0x4001100C)
#define USART1_CR2 (*(volatile uint32_t*)0x40011010)
#define USART1_CR3 (*(volatile uint32_t*)0x40011014)
#define USART1_GTPR (*(volatile uint32_t*)0x40011018)
#define USART2_SR (*(volatile uint32_t*)0x40004400)
#define USART2_DR (*(volatile uint32_t*)0x40004404)
#define USART2_BRR (*(volatile uint32_t*)0x40004408)
#define USART2_CR1 (*(volatile uint32_t*)0x4000440C)
#define USART2_CR2 (*(volatile uint32_t*)0x40004410)
#define USART2_CR3 (*(volatile uint32_t*)0x40004414)
#define USART2_GTPR (*(volatile uint32_t*)0x40004418)
#define USART3_SR (*(volatile uint32_t*)0x40004800)
#define USART3_DR (*(volatile uint32_t*)0x40004804)
#define USART3_BRR (*(volatile uint32_t*)0x40004808)
#define USART3_CR1 (*(volatile uint32_t*)0x4000480C)
#define USART3_CR2 (*(volatile uint32_t*)0x40004810)
#define USART3_CR3 (*(volatile uint32_t*)0x40004814)
#define USART3_GTPR (*(volatile uint32_t*)0x40004818)
#define UART4_SR (*(volatile uint32_t*)0x40004C00)
#define UART4_DR (*(volatile uint32_t*)0x40004C04)
#define UART4_BRR (*(volatile uint32_t*)0x40004C08)
#define UART4_CR1 (*(volatile uint32_t*)0x40004C0C)
#define UART4_CR2 (*(volatile uint32_t*)0x40004C10)
#define UART4_CR3 (*(volatile uint32_t*)0x40004C14)
#define UART5_SR (*(volatile uint32_t*)0x40005000)
#define UART5_DR (*(volatile uint32_t*)0x40005004)
#define UART5_BRR (*(volatile uint32_t*)0x40005008)
#define UART5_CR1 (*(volatile uint32_t*)0x4000500C)
#define UART5_CR2 (*(volatile uint32_t*)0x40005010)
#define UART5_CR3 (*(volatile uint32_t*)0x40005014)
#define USART6_SR (*(volatile uint32_t*)0x40011400)
#define USART6_DR (*(volatile uint32_t*)0x40011404)
#define USART6_BRR (*(volatile uint32_t*)0x40011408)
#define USART6_CR1 (*(volatile uint32_t*)0x4001140C)
#define USART6_CR2 (*(volatile uint32_t*)0x40011410)
#define USART6_CR3 (*(volatile uint32_t*)0x40011414)
#define USART6_GTPR (*(volatile uint32_t*)0x40011418)
#define ADC_CSR (*(volatile uint32_t*)0x40012300)
#define ADC_CCR (*(volatile uint32_t*)0x40012304)
#define ADC_CDR (*(volatile uint32_t*)0x40012308)
#define ADC1_SR (*(volatile uint32_t*)0x40012000)
#define ADC1_CR1 (*(volatile uint32_t*)0x40012004)
#define ADC1_CR2 (*(volatile uint32_t*)0x40012008)
#define ADC1_SMPR1 (*(volatile uint32_t*)0x4001200C)
#define ADC1_SMPR2 (*(volatile uint32_t*)0x40012010)
#define ADC1_JOFR1 (*(volatile uint32_t*)0x40012014)
#define ADC1_JOFR2 (*(volatile uint32_t*)0x40012018)
#define ADC1_JOFR3 (*(volatile uint32_t*)0x4001201C)
#define ADC1_JOFR4 (*(volatile uint32_t*)0x40012020)
#define ADC1_HTR (*(volatile uint32_t*)0x40012024)
#define ADC1_LTR (*(volatile uint32_t*)0x40012028)
#define ADC1_SQR1 (*(volatile uint32_t*)0x4001202C)
#define ADC1_SQR2 (*(volatile uint32_t*)0x40012030)
#define ADC1_SQR3 (*(volatile uint32_t*)0x40012034)
#define ADC1_JSQR (*(volatile uint32_t*)0x40012038)
#define ADC1_JDR1 (*(volatile uint32_t*)0x4001203C)
#define ADC1_JDR2 (*(volatile uint32_t*)0x40012040)
#define ADC1_JDR3 (*(volatile uint32_t*)0x40012044)
#define ADC1_JDR4 (*(volatile uint32_t*)0x40012048)
#define ADC1_DR (*(volatile uint32_t*)0x4001204C)
#define ADC2_SR (*(volatile uint32_t*)0x40012100)
#define ADC2_CR1 (*(volatile uint32_t*)0x40012104)
#define ADC2_CR2 (*(volatile uint32_t*)0x40012108)
#define ADC2_SMPR1 (*(volatile uint32_t*)0x4001210C)
#define ADC2_SMPR2 (*(volatile uint32_t*)0x40012110)
#define ADC2_JOFR1 (*(volatile uint32_t*)0x40012114)
#define ADC2_JOFR2 (*(volatile uint32_t*)0x40012118)
#define ADC2_JOFR3 (*(volatile uint32_t*)0x4001211C)
#define ADC2_JOFR4 (*(volatile uint32_t*)0x40012120)
#define ADC2_HTR (*(volatile uint32_t*)0x40012124)
#define ADC2_LTR (*(volatile uint32_t*)0x40012128)
#define ADC2_SQR1 (*(volatile uint32_t*)0x4001212C)
#define ADC2_SQR2 (*(volatile uint32_t*)0x40012130)
#define ADC2_SQR3 (*(volatile uint32_t*)0x40012134)
#define ADC2_JSQR (*(volatile uint32_t*)0x40012138)
#define ADC2_JDR1 (*(volatile uint32_t*)0x4001213C)
#define ADC2_JDR2 (*(volatile uint32_t*)0x40012140)
#define ADC2_JDR3 (*(volatile uint32_t*)0x40012144)
#define ADC2_JDR4 (*(volatile uint32_t*)0x40012148)
#define ADC2_DR (*(volatile uint32_t*)0x4001214C)
#define ADC3_SR (*(volatile uint32_t*)0x40012200)
#define ADC3_CR1 (*(volatile uint32_t*)0x40012204)
#define ADC3_CR2 (*(volatile uint32_t*)0x40012208)
#define ADC3_SMPR1 (*(volatile uint32_t*)0x4001220C)
#define ADC3_SMPR2 (*(volatile uint32_t*)0x40012210)
#define ADC3_JOFR1 (*(volatile uint32_t*)0x40012214)
#define ADC3_JOFR2 (*(volatile uint32_t*)0x40012218)
#define ADC3_JOFR3 (*(volatile uint32_t*)0x4001221C)
#define ADC3_JOFR4 (*(volatile uint32_t*)0x40012220)
#define ADC3_HTR (*(volatile uint32_t*)0x40012224)
#define ADC3_LTR (*(volatile uint32_t*)0x40012228)
#define ADC3_SQR1 (*(volatile uint32_t*)0x4001222C)
#define ADC3_SQR2 (*(volatile uint32_t*)0x40012230)
#define ADC3_SQR3 (*(volatile uint32_t*)0x40012234)
#define ADC3_JSQR (*(volatile uint32_t*)0x40012238)
#define ADC3_JDR1 (*(volatile uint32_t*)0x4001223C)
#define ADC3_JDR2 (*(volatile uint32_t*)0x40012240)
#define ADC3_JDR3 (*(volatile uint32_t*)0x40012244)
#define ADC3_JDR4 (*(volatile uint32_t*)0x40012248)
#define ADC3_DR (*(volatile uint32_t*)0x4001224C)
#define DAC_CR (*(volatile uint32_t*)0x40007400)
#define DAC_SWTRIGR (*(volatile uint32_t*)0x40007404)
#define DAC_DHR12R1 (*(volatile uint32_t*)0x40007408)
#define DAC_DHR12L1 (*(volatile uint32_t*)0x4000740C)
#define DAC_DHR8R1 (*(volatile uint32_t*)0x40007410)
#define DAC_DHR12R2 (*(volatile uint32_t*)0x40007414)
#define DAC_DHR12L2 (*(volatile uint32_t*)0x40007418)
#define DAC_DHR8R2 (*(volatile uint32_t*)0x4000741C)
#define DAC_DHR12RD (*(volatile uint32_t*)0x40007420)
#define DAC_DHR12LD (*(volatile uint32_t*)0x40007424)
#define DAC_DHR8RD (*(volatile uint32_t*)0x40007428)
#define DAC_DOR1 (*(volatile uint32_t*)0x4000742C)
#define DAC_DOR2 (*(volatile uint32_t*)0x40007430)
#define DAC_SR (*(volatile uint32_t*)0x40007434)
#define DCMI_CR (*(volatile uint32_t*)0x50050000)
#define DCMI_SR (*(volatile uint32_t*)0x50050004)
#define DCMI_RIS (*(volatile uint32_t*)0x50050008)
#define DCMI_IER (*(volatile uint32_t*)0x5005000C)
#define DCMI_MIS (*(volatile uint32_t*)0x50050010)
#define DCMI_ICR (*(volatile uint32_t*)0x50050014)
#define DCMI_ESCR (*(volatile uint32_t*)0x50050018)
#define DCMI_ESUR (*(volatile uint32_t*)0x5005001C)
#define DCMI_CWSTRT (*(volatile uint32_t*)0x50050020)
#define DCMI_CWSIZE (*(volatile uint32_t*)0x50050024)
#define DCMI_DR (*(volatile uint32_t*)0x50050028)
#define FLASH_ACR (*(volatile uint32_t*)0x40023C00)
#define FLASH_KEYR (*(volatile uint32_t*)0x40023C04)
#define FLASH_OPTKEYR (*(volatile uint32_t*)0x40023C08)
#define FLASH_SR (*(volatile uint32_t*)0x40023C0C)
#define FLASH_CR (*(volatile uint32_t*)0x40023C10)
#define FLASH_OPTCR (*(volatile uint32_t*)0x40023C14)
#define CRC_DR (*(volatile uint32_t*)0x40023000)
#define CRC_IDR (*(volatile uint32_t*)0x40023004)
#define CRC_CR (*(volatile uint32_t*)0x40023008)
#define OTG_FS_GOTGCTL (*(volatile uint32_t*)0x50000000)
#define OTG_FS_GOTGINT (*(volatile uint32_t*)0x50000004)
#define OTG_FS_GAHBCFG (*(volatile uint32_t*)0x50000008)
#define OTG_FS_GUSBCFG (*(volatile uint32_t*)0x5000000C)
#define OTG_FS_GRSTCTL (*(volatile uint32_t*)0x50000010)
#define OTG_FS_GINTSTS (*(volatile uint32_t*)0x50000014)
#define OTG_FS_GINTMSK (*(volatile uint32_t*)0x50000018)
#define OTG_FS_GRXSTSR (*(volatile uint32_t*)0x5000001C)
#define OTG_FS_GRXSTSR_DEV OTG_FS_GRXSTSR
#define OTG_FS_GRXSTSP (*(volatile uint32_t*)0x50000020)
#define OTG_FS_GRXSTSP_DEV OTG_FS_GRXSTSP
#define OTG_FS_GRXFSIZ (*(volatile uint32_t*)0x50000024)
#define OTG_FS_GNPTXFSIZ (*(volatile uint32_t*)0x50000028)
#define OTG_FS_GNPTXSTS (*(volatile uint32_t*)0x5000002C)
#define OTG_FS_GCCFG (*(volatile uint32_t*)0x50000038)
#define OTG_FS_CID (*(volatile uint32_t*)0x5000003C)
#define OTG_FS_HPTXFSIZ (*(volatile uint32_t*)0x50000100)
#define OTG_FS_DIEPTXF1 (*(volatile uint32_t*)0x50000104)
#define OTG_FS_DIEPTXF2 (*(volatile uint32_t*)0x50000108)
#define OTG_FS_DIEPTXF3 (*(volatile uint32_t*)0x5000010C)
#define OTG_FS_DIEPTXF4 (*(volatile uint32_t*)0x50000110)
#define OTG_FS_HCFG (*(volatile uint32_t*)0x50000400)
#define OTG_FS_HFIR (*(volatile uint32_t*)0x50000404)
#define OTG_FS_HFNUM (*(volatile uint32_t*)0x50000408)
#define OTG_FS_HPTXSTS (*(volatile uint32_t*)0x50000410)
#define OTG_FS_HAINT (*(volatile uint32_t*)0x50000414)
#define OTG_FS_HAINTMSK (*(volatile uint32_t*)0x50000418)
#define OTG_FS_HPRT (*(volatile uint32_t*)0x50000440)
#define OTG_FS_HCCHAR0 (*(volatile uint32_t*)0x50000500)
#define OTG_FS_HCINT0 (*(volatile uint32_t*)0x50000508)
#define OTG_FS_HCINTMSK0 (*(volatile uint32_t*)0x5000050C)
#define OTG_FS_HCTSIZ0 (*(volatile uint32_t*)0x50000510)
#define OTG_FS_HCCHAR1 (*(volatile uint32_t*)0x50000520)
#define OTG_FS_HCINT1 (*(volatile uint32_t*)0x50000528)
#define OTG_FS_HCINTMSK1 (*(volatile uint32_t*)0x5000052C)
#define OTG_FS_HCTSIZ1 (*(volatile uint32_t*)0x50000530)
#define OTG_FS_HCCHAR2 (*(volatile uint32_t*)0x50000540)
#define OTG_FS_HCINT2 (*(volatile uint32_t*)0x50000548)
#define OTG_FS_HCINTMSK2 (*(volatile uint32_t*)0x5000054C)
#define OTG_FS_HCTSIZ2 (*(volatile uint32_t*)0x50000550)
#define OTG_FS_HCCHAR3 (*(volatile uint32_t*)0x50000560)
#define OTG_FS_HCINT3 (*(volatile uint32_t*)0x50000568)
#define OTG_FS_HCINTMSK3 (*(volatile uint32_t*)0x5000056C)
#define OTG_FS_HCTSIZ3 (*(volatile uint32_t*)0x50000570)
#define OTG_FS_HCCHAR4 (*(volatile uint32_t*)0x50000580)
#define OTG_FS_HCINT4 (*(volatile uint32_t*)0x50000588)
#define OTG_FS_HCINTMSK4 (*(volatile uint32_t*)0x5000058C)
#define OTG_FS_HCTSIZ4 (*(volatile uint32_t*)0x50000590)
#define OTG_FS_HCCHAR5 (*(volatile uint32_t*)0x500005A0)
#define OTG_FS_HCINT5 (*(volatile uint32_t*)0x500005A8)
#define OTG_FS_HCINTMSK5 (*(volatile uint32_t*)0x500005AC)
#define OTG_FS_HCTSIZ5 (*(volatile uint32_t*)0x500005B0)
#define OTG_FS_HCCHAR6 (*(volatile uint32_t*)0x500005C0)
#define OTG_FS_HCINT6 (*(volatile uint32_t*)0x500005C8)
#define OTG_FS_HCINTMSK6 (*(volatile uint32_t*)0x500005CC)
#define OTG_FS_HCTSIZ6 (*(volatile uint32_t*)0x500005D0)
#define OTG_FS_HCCHAR7 (*(volatile uint32_t*)0x500005E0)
#define OTG_FS_HCINT7 (*(volatile uint32_t*)0x500005E8)
#define OTG_FS_HCINTMSK7 (*(volatile uint32_t*)0x500005EC)
#define OTG_FS_HCTSIZ7 (*(volatile uint32_t*)0x500005F0)
#define OTG_FS_HCCHAR8 (*(volatile uint32_t*)0x50000600)
#define OTG_FS_HCINT8 (*(volatile uint32_t*)0x50000608)
#define OTG_FS_HCINTMSK8 (*(volatile uint32_t*)0x5000060C)
#define OTG_FS_HCTSIZ8 (*(volatile uint32_t*)0x50000610)
#define OTG_FS_HCCHAR9 (*(volatile uint32_t*)0x50000620)
#define OTG_FS_HCINT9 (*(volatile uint32_t*)0x50000628)
#define OTG_FS_HCINTMSK9 (*(volatile uint32_t*)0x5000062C)
#define OTG_FS_HCTSIZ9 (*(volatile uint32_t*)0x50000630)
#define OTG_FS_HCCHAR10 (*(volatile uint32_t*)0x50000640)
#define OTG_FS_HCINT10 (*(volatile uint32_t*)0x50000648)
#define OTG_FS_HCINTMSK10 (*(volatile uint32_t*)0x5000064C)
#define OTG_FS_HCTSIZ10 (*(volatile uint32_t*)0x50000650)
#define OTG_FS_HCCHAR11 (*(volatile uint32_t*)0x50000660)
#define OTG_FS_HCINT11 (*(volatile uint32_t*)0x50000668)
#define OTG_FS_HCINTMSK11 (*(volatile uint32_t*)0x5000066C)
#define OTG_FS_HCTSIZ11 (*(volatile uint32_t*)0x50000670)
#define OTG_FS_HCCHAR12 (*(volatile uint32_t*)0x50000680)
#define OTG_FS_HCINT12 (*(volatile uint32_t*)0x50000688)
#define OTG_FS_HCINTMSK12 (*(volatile uint32_t*)0x5000068C)
#define OTG_FS_HCTSIZ12 (*(volatile uint32_t*)0x50000690)
#define OTG_FS_HCCHAR13 (*(volatile uint32_t*)0x500006A0)
#define OTG_FS_HCINT13 (*(volatile uint32_t*)0x500006A8)
#define OTG_FS_HCINTMSK13 (*(volatile uint32_t*)0x500006AC)
#define OTG_FS_HCTSIZ13 (*(volatile uint32_t*)0x500006B0)
#define OTG_FS_HCCHAR14 (*(volatile uint32_t*)0x500006C0)
#define OTG_FS_HCINT14 (*(volatile uint32_t*)0x500006C8)
#define OTG_FS_HCINTMSK14 (*(volatile uint32_t*)0x500006CC)
#define OTG_FS_HCTSIZ14 (*(volatile uint32_t*)0x500006D0)
#define OTG_FS_HCCHAR15 (*(volatile uint32_t*)0x500006E0)
#define OTG_FS_HCINT15 (*(volatile uint32_t*)0x500006E8)
#define OTG_FS_HCINTMSK15 (*(volatile uint32_t*)0x500006EC)
#define OTG_FS_HCTSIZ15 (*(volatile uint32_t*)0x500006F0)
#define OTG_FS_DCFG (*(volatile uint32_t*)0x50000800)
#define OTG_FS_DCTL (*(volatile uint32_t*)0x50000804)
#define OTG_FS_DSTS (*(volatile uint32_t*)0x50000808)
#define OTG_FS_DIEPMSK (*(volatile uint32_t*)0x50000810)
#define OTG_FS_DOEPMSK (*(volatile uint32_t*)0x50000814)
#define OTG_FS_DAINT (*(volatile uint32_t*)0x50000818)
#define OTG_FS_DAINTMSK (*(volatile uint32_t*)0x5000081C)
#define OTG_FS_DVBUSDIS (*(volatile uint32_t*)0x50000828)
#define OTG_FS_DVBUSPULSE (*(volatile uint32_t*)0x5000082C)
#define OTG_FS_DIEPEMPMSK (*(volatile uint32_t*)0x50000834)
#define OTG_FS_DIEPCTL0 (*(volatile uint32_t*)0x50000900)
#define OTG_FS_DIEPINT0 (*(volatile uint32_t*)0x50000908)
#define OTG_FS_DIEPTSIZ0 (*(volatile uint32_t*)0x50000910)
#define OTG_FS_DTXFSTS0 (*(volatile uint32_t*)0x50000918)
#define OTG_FS_DIEPCTL1 (*(volatile uint32_t*)0x50000920)
#define OTG_FS_DIEPINT1 (*(volatile uint32_t*)0x50000928)
#define OTG_FS_DIEPTSIZ1 (*(volatile uint32_t*)0x50000930)
#define OTG_FS_DTXFSTS1 (*(volatile uint32_t*)0x50000938)
#define OTG_FS_DIEPCTL2 (*(volatile uint32_t*)0x50000940)
#define OTG_FS_DIEPINT2 (*(volatile uint32_t*)0x50000948)
#define OTG_FS_DIEPTSIZ2 (*(volatile uint32_t*)0x50000950)
#define OTG_FS_DTXFSTS2 (*(volatile uint32_t*)0x50000958)
#define OTG_FS_DIEPCTL3 (*(volatile uint32_t*)0x50000960)
#define OTG_FS_DIEPINT3 (*(volatile uint32_t*)0x50000968)
#define OTG_FS_DIEPTSIZ3 (*(volatile uint32_t*)0x50000970)
#define OTG_FS_DTXFSTS3 (*(volatile uint32_t*)0x50000978)
#define OTG_FS_DIEPCTL4 (*(volatile uint32_t*)0x50000980)
#define OTG_FS_DIEPINT4 (*(volatile uint32_t*)0x50000988)
#define OTG_FS_DIEPTSIZ4 (*(volatile uint32_t*)0x50000990)
#define OTG_FS_DTXFSTS4 (*(volatile uint32_t*)0x50000998)
#define OTG_FS_DIEPCTL5 (*(volatile uint32_t*)0x500009A0)
#define OTG_FS_DIEPINT5 (*(volatile uint32_t*)0x500009A8)
#define OTG_FS_DIEPTSIZ5 (*(volatile uint32_t*)0x500009B0)
#define OTG_FS_DIEPCTL6 (*(volatile uint32_t*)0x500009C0)
#define OTG_FS_DIEPINT6 (*(volatile uint32_t*)0x500009C8)
#define OTG_FS_DIEPTSIZ6 (*(volatile uint32_t*)0x500009D0)
#define OTG_FS_DIEPCTL7 (*(volatile uint32_t*)0x500009E0)
#define OTG_FS_DIEPINT7 (*(volatile uint32_t*)0x500009E8)
#define OTG_FS_DIEPTSIZ7 (*(volatile uint32_t*)0x500009F0)
#define OTG_FS_DIEPCTL8 (*(volatile uint32_t*)0x50000A00)
#define OTG_FS_DIEPINT8 (*(volatile uint32_t*)0x50000A08)
#define OTG_FS_DIEPTSIZ8 (*(volatile uint32_t*)0x50000A10)
#define OTG_FS_DIEPCTL9 (*(volatile uint32_t*)0x50000A20)
#define OTG_FS_DIEPINT9 (*(volatile uint32_t*)0x50000A28)
#define OTG_FS_DIEPTSIZ9 (*(volatile uint32_t*)0x50000A30)
#define OTG_FS_DIEPCTL10 (*(volatile uint32_t*)0x50000A40)
#define OTG_FS_DIEPINT10 (*(volatile uint32_t*)0x50000A48)
#define OTG_FS_DIEPTSIZ10 (*(volatile uint32_t*)0x50000A50)
#define OTG_FS_DIEPCTL11 (*(volatile uint32_t*)0x50000A60)
#define OTG_FS_DIEPINT11 (*(volatile uint32_t*)0x50000A68)
#define OTG_FS_DIEPTSIZ11 (*(volatile uint32_t*)0x50000A70)
#define OTG_FS_DIEPCTL12 (*(volatile uint32_t*)0x50000A80)
#define OTG_FS_DIEPINT12 (*(volatile uint32_t*)0x50000A88)
#define OTG_FS_DIEPTSIZ12 (*(volatile uint32_t*)0x50000A90)
#define OTG_FS_DIEPCTL13 (*(volatile uint32_t*)0x50000AA0)
#define OTG_FS_DIEPINT13 (*(volatile uint32_t*)0x50000AA8)
#define OTG_FS_DIEPTSIZ13 (*(volatile uint32_t*)0x50000AB0)
#define OTG_FS_DIEPCTL14 (*(volatile uint32_t*)0x50000AC0)
#define OTG_FS_DIEPINT14 (*(volatile uint32_t*)0x50000AC8)
#define OTG_FS_DIEPTSIZ14 (*(volatile uint32_t*)0x50000AD0)
#define OTG_FS_DIEPCTL15 (*(volatile uint32_t*)0x50000AE0)
#define OTG_FS_DIEPINT15 (*(volatile uint32_t*)0x50000AE8)
#define OTG_FS_DIEPTSIZ15 (*(volatile uint32_t*)0x50000AF0)
#define OTG_FS_DOEPCTL0 (*(volatile uint32_t*)0x50000B00)
#define OTG_FS_DOEPINT0 (*(volatile uint32_t*)0x50000B08)
#define OTG_FS_DOEPTSIZ0 (*(volatile uint32_t*)0x50000B10)
#define OTG_FS_DOEPCTL1 (*(volatile uint32_t*)0x50000B20)
#define OTG_FS_DOEPINT1 (*(volatile uint32_t*)0x50000B28)
#define OTG_FS_DOEPTSIZ1 (*(volatile uint32_t*)0x50000B30)
#define OTG_FS_DOEPCTL2 (*(volatile uint32_t*)0x50000B40)
#define OTG_FS_DOEPINT2 (*(volatile uint32_t*)0x50000B48)
#define OTG_FS_DOEPTSIZ2 (*(volatile uint32_t*)0x50000B50)
#define OTG_FS_DOEPCTL3 (*(volatile uint32_t*)0x50000B60)
#define OTG_FS_DOEPINT3 (*(volatile uint32_t*)0x50000B68)
#define OTG_FS_DOEPTSIZ3 (*(volatile uint32_t*)0x50000B70)
#define OTG_FS_DOEPCTL4 (*(volatile uint32_t*)0x50000B80)
#define OTG_FS_DOEPINT4 (*(volatile uint32_t*)0x50000B88)
#define OTG_FS_DOEPTSIZ4 (*(volatile uint32_t*)0x50000B90)
#define OTG_FS_DOEPCTL5 (*(volatile uint32_t*)0x50000BA0)
#define OTG_FS_DOEPINT5 (*(volatile uint32_t*)0x50000BA8)
#define OTG_FS_DOEPTSIZ5 (*(volatile uint32_t*)0x50000BB0)
#define OTG_FS_DOEPCTL6 (*(volatile uint32_t*)0x50000BC0)
#define OTG_FS_DOEPINT6 (*(volatile uint32_t*)0x50000BC8)
#define OTG_FS_DOEPTSIZ6 (*(volatile uint32_t*)0x50000BD0)
#define OTG_FS_DOEPCTL7 (*(volatile uint32_t*)0x50000BE0)
#define OTG_FS_DOEPINT7 (*(volatile uint32_t*)0x50000BE8)
#define OTG_FS_DOEPTSIZ7 (*(volatile uint32_t*)0x50000BF0)
#define OTG_FS_DOEPCTL8 (*(volatile uint32_t*)0x50000C00)
#define OTG_FS_DOEPINT8 (*(volatile uint32_t*)0x50000C08)
#define OTG_FS_DOEPTSIZ8 (*(volatile uint32_t*)0x50000C10)
#define OTG_FS_DOEPCTL9 (*(volatile uint32_t*)0x50000C20)
#define OTG_FS_DOEPINT9 (*(volatile uint32_t*)0x50000C28)
#define OTG_FS_DOEPTSIZ9 (*(volatile uint32_t*)0x50000C30)
#define OTG_FS_DOEPCTL10 (*(volatile uint32_t*)0x50000C40)
#define OTG_FS_DOEPINT10 (*(volatile uint32_t*)0x50000C48)
#define OTG_FS_DOEPTSIZ10 (*(volatile uint32_t*)0x50000C50)
#define OTG_FS_DOEPCTL11 (*(volatile uint32_t*)0x50000C60)
#define OTG_FS_DOEPINT11 (*(volatile uint32_t*)0x50000C68)
#define OTG_FS_DOEPTSIZ11 (*(volatile uint32_t*)0x50000C70)
#define OTG_FS_DOEPCTL12 (*(volatile uint32_t*)0x50000C80)
#define OTG_FS_DOEPINT12 (*(volatile uint32_t*)0x50000C88)
#define OTG_FS_DOEPTSIZ12 (*(volatile uint32_t*)0x50000C90)
#define OTG_FS_DOEPCTL13 (*(volatile uint32_t*)0x50000CA0)
#define OTG_FS_DOEPINT13 (*(volatile uint32_t*)0x50000CA8)
#define OTG_FS_DOEPTSIZ13 (*(volatile uint32_t*)0x50000CB0)
#define OTG_FS_DOEPCTL14 (*(volatile uint32_t*)0x50000CC0)
#define OTG_FS_DOEPINT14 (*(volatile uint32_t*)0x50000CC8)
#define OTG_FS_DOEPTSIZ14 (*(volatile uint32_t*)0x50000CD0)
#define OTG_FS_DOEPCTL15 (*(volatile uint32_t*)0x50000CE0)
#define OTG_FS_DOEPINT15 (*(volatile uint32_t*)0x50000CE8)
#define OTG_FS_DOEPTSIZ15 (*(volatile uint32_t*)0x50000CF0)
#define OTG_FS_PCGCCTL (*(volatile uint32_t*)0x50000E00)
#define OTG_HS_GOTGCTL (*(volatile uint32_t*)0x40040000)
#define OTG_HS_GOTGINT (*(volatile uint32_t*)0x40040004)
#define OTG_HS_GAHBCFG (*(volatile uint32_t*)0x40040008)
#define OTG_HS_GUSBCFG (*(volatile uint32_t*)0x4004000C)
#define OTG_HS_GRSTCTL (*(volatile uint32_t*)0x40040010)
#define OTG_HS_GINTSTS (*(volatile uint32_t*)0x40040014)
#define OTG_HS_GINTMSK (*(volatile uint32_t*)0x40040018)
#define OTG_HS_GRXSTSR (*(volatile uint32_t*)0x4004001C)
#define OTG_HS_GRXSTSP (*(volatile uint32_t*)0x40040020)
#define OTG_HS_GRXFSIZ (*(volatile uint32_t*)0x40040024)
#define OTG_HS_GNPTXFSIZ (*(volatile uint32_t*)0x40040028)
#define OTG_HS_TX0FSIZ OTG_HS_GNPTXFSIZ
#define OTG_HS_GNPTXSTS (*(volatile uint32_t*)0x4004002C)
#define OTG_HS_GI2CCTL (*(volatile uint32_t*)0x40040030)
#define OTG_HS_GCCFG (*(volatile uint32_t*)0x40040038)
#define OTG_HS_CID (*(volatile uint32_t*)0x4004003C)
#define OTG_HS_HPTXFSIZ (*(volatile uint32_t*)0x40040100)
#define OTG_HS_DIEPTXF1 (*(volatile uint32_t*)0x40040104)
#define OTG_HS_DIEPTXF2 (*(volatile uint32_t*)0x40040108)
#define OTG_HS_DIEPTXF3 (*(volatile uint32_t*)0x4004010C)
#define OTG_HS_DIEPTXF4 (*(volatile uint32_t*)0x40040110)
#define OTG_HS_HCFG (*(volatile uint32_t*)0x40040400)
#define OTG_HS_HFIR (*(volatile uint32_t*)0x40040404)
#define OTG_HS_HFNUM (*(volatile uint32_t*)0x40040408)
#define OTG_HS_HPTXSTS (*(volatile uint32_t*)0x40040410)
#define OTG_HS_HAINT (*(volatile uint32_t*)0x40040414)
#define OTG_HS_HAINTMSK (*(volatile uint32_t*)0x40040418)
#define OTG_HS_HPRT (*(volatile uint32_t*)0x40040440)
#define OTG_HS_HCCHAR0 (*(volatile uint32_t*)0x40040500)
#define OTG_HS_HCSPLT0 (*(volatile uint32_t*)0x40040504)
#define OTG_HS_HCINT0 (*(volatile uint32_t*)0x40040508)
#define OTG_HS_HCINTMSK0 (*(volatile uint32_t*)0x4004050C)
#define OTG_HS_HCTSIZ0 (*(volatile uint32_t*)0x40040510)
#define OTG_HS_HCDMA0 (*(volatile uint32_t*)0x40040514)
#define OTG_HS_HCCHAR1 (*(volatile uint32_t*)0x40040520)
#define OTG_HS_HCSPLT1 (*(volatile uint32_t*)0x40040524)
#define OTG_HS_HCINT1 (*(volatile uint32_t*)0x40040528)
#define OTG_HS_HCINTMSK1 (*(volatile uint32_t*)0x4004052C)
#define OTG_HS_HCTSIZ1 (*(volatile uint32_t*)0x40040530)
#define OTG_HS_HCDMA1 (*(volatile uint32_t*)0x40040534)
#define OTG_HS_HCCHAR2 (*(volatile uint32_t*)0x40040540)
#define OTG_HS_HCSPLT2 (*(volatile uint32_t*)0x40040544)
#define OTG_HS_HCINT2 (*(volatile uint32_t*)0x40040548)
#define OTG_HS_HCINTMSK2 (*(volatile uint32_t*)0x4004054C)
#define OTG_HS_HCTSIZ2 (*(volatile uint32_t*)0x40040550)
#define OTG_HS_HCDMA2 (*(volatile uint32_t*)0x40040554)
#define OTG_HS_HCCHAR3 (*(volatile uint32_t*)0x40040560)
#define OTG_HS_HCSPLT3 (*(volatile uint32_t*)0x40040564)
#define OTG_HS_HCINT3 (*(volatile uint32_t*)0x40040568)
#define OTG_HS_HCINTMSK3 (*(volatile uint32_t*)0x4004056C)
#define OTG_HS_HCTSIZ3 (*(volatile uint32_t*)0x40040570)
#define OTG_HS_HCDMA3 (*(volatile uint32_t*)0x40040574)
#define OTG_HS_HCCHAR4 (*(volatile uint32_t*)0x40040580)
#define OTG_HS_HCSPLT4 (*(volatile uint32_t*)0x40040584)
#define OTG_HS_HCINT4 (*(volatile uint32_t*)0x40040588)
#define OTG_HS_HCINTMSK4 (*(volatile uint32_t*)0x4004058C)
#define OTG_HS_HCTSIZ4 (*(volatile uint32_t*)0x40040590)
#define OTG_HS_HCDMA4 (*(volatile uint32_t*)0x40040594)
#define OTG_HS_HCCHAR5 (*(volatile uint32_t*)0x400405A0)
#define OTG_HS_HCSPLT5 (*(volatile uint32_t*)0x400405A4)
#define OTG_HS_HCINT5 (*(volatile uint32_t*)0x400405A8)
#define OTG_HS_HCINTMSK5 (*(volatile uint32_t*)0x400405AC)
#define OTG_HS_HCTSIZ5 (*(volatile uint32_t*)0x400405B0)
#define OTG_HS_HCDMA5 (*(volatile uint32_t*)0x400405B4)
#define OTG_HS_HCCHAR6 (*(volatile uint32_t*)0x400405C0)
#define OTG_HS_HCSPLT6 (*(volatile uint32_t*)0x400405C4)
#define OTG_HS_HCINT6 (*(volatile uint32_t*)0x400405C8)
#define OTG_HS_HCINTMSK6 (*(volatile uint32_t*)0x400405CC)
#define OTG_HS_HCTSIZ6 (*(volatile uint32_t*)0x400405D0)
#define OTG_HS_HCDMA6 (*(volatile uint32_t*)0x400405D4)
#define OTG_HS_HCCHAR7 (*(volatile uint32_t*)0x400405E0)
#define OTG_HS_HCSPLT7 (*(volatile uint32_t*)0x400405E4)
#define OTG_HS_HCINT7 (*(volatile uint32_t*)0x400405E8)
#define OTG_HS_HCINTMSK7 (*(volatile uint32_t*)0x400405EC)
#define OTG_HS_HCTSIZ7 (*(volatile uint32_t*)0x400405F0)
#define OTG_HS_HCDMA7 (*(volatile uint32_t*)0x400405F4)
#define OTG_HS_HCCHAR8 (*(volatile uint32_t*)0x40040600)
#define OTG_HS_HCSPLT8 (*(volatile uint32_t*)0x40040604)
#define OTG_HS_HCINT8 (*(volatile uint32_t*)0x40040608)
#define OTG_HS_HCINTMSK8 (*(volatile uint32_t*)0x4004060C)
#define OTG_HS_HCTSIZ8 (*(volatile uint32_t*)0x40040610)
#define OTG_HS_HCDMA8 (*(volatile uint32_t*)0x40040614)
#define OTG_HS_HCCHAR9 (*(volatile uint32_t*)0x40040620)
#define OTG_HS_HCSPLT9 (*(volatile uint32_t*)0x40040624)
#define OTG_HS_HCINT9 (*(volatile uint32_t*)0x40040628)
#define OTG_HS_HCINTMSK9 (*(volatile uint32_t*)0x4004062C)
#define OTG_HS_HCTSIZ9 (*(volatile uint32_t*)0x40040630)
#define OTG_HS_HCDMA9 (*(volatile uint32_t*)0x40040634)
#define OTG_HS_HCCHAR10 (*(volatile uint32_t*)0x40040640)
#define OTG_HS_HCSPLT10 (*(volatile uint32_t*)0x40040644)
#define OTG_HS_HCINT10 (*(volatile uint32_t*)0x40040648)
#define OTG_HS_HCINTMSK10 (*(volatile uint32_t*)0x4004064C)
#define OTG_HS_HCTSIZ10 (*(volatile uint32_t*)0x40040650)
#define OTG_HS_HCDMA10 (*(volatile uint32_t*)0x40040654)
#define OTG_HS_HCCHAR11 (*(volatile uint32_t*)0x40040660)
#define OTG_HS_HCSPLT11 (*(volatile uint32_t*)0x40040664)
#define OTG_HS_HCINT11 (*(volatile uint32_t*)0x40040668)
#define OTG_HS_HCINTMSK11 (*(volatile uint32_t*)0x4004066C)
#define OTG_HS_HCTSIZ11 (*(volatile uint32_t*)0x40040670)
#define OTG_HS_HCDMA11 (*(volatile uint32_t*)0x40040674)
#define OTG_HS_DCFG (*(volatile uint32_t*)0x40040800)
#define OTG_HS_DCTL (*(volatile uint32_t*)0x40040804)
#define OTG_HS_DSTS (*(volatile uint32_t*)0x40040808)
#define OTG_HS_DIEPMSK (*(volatile uint32_t*)0x40040810)
#define OTG_HS_DOEPMSK (*(volatile uint32_t*)0x40040814)
#define OTG_HS_DAINT (*(volatile uint32_t*)0x40040818)
#define OTG_HS_DAINTMSK (*(volatile uint32_t*)0x4004081C)
#define OTG_HS_DVBUSDIS (*(volatile uint32_t*)0x40040828)
#define OTG_HS_DVBUSPULSE (*(volatile uint32_t*)0x4004082C)
#define OTG_HS_DTHRCTL (*(volatile uint32_t*)0x40040830)
#define OTG_HS_DIEPEMPMSK (*(volatile uint32_t*)0x40040834)
#define OTG_HS_DEACHINT (*(volatile uint32_t*)0x40040838)
#define OTG_HS_DEACHINTMSK (*(volatile uint32_t*)0x4004083C)
#define OTG_HS_DIEPEACHMSK1 (*(volatile uint32_t*)0x40040840)
#define OTG_HS_DOEPEACHMSK1 (*(volatile uint32_t*)0x40040880)
#define OTG_HS_DIEPCTL0 (*(volatile uint32_t*)0x40040900)
#define OTG_HS_DTXFSTS0 (*(volatile uint32_t*)0x40040918)
#define OTG_HS_DIEPCTL1 (*(volatile uint32_t*)0x40040920)
#define OTG_HS_DTXFSTS1 (*(volatile uint32_t*)0x40040938)
#define OTG_HS_DIEPCTL2 (*(volatile uint32_t*)0x40040940)
#define OTG_HS_DTXFSTS2 (*(volatile uint32_t*)0x40040958)
#define OTG_HS_DIEPCTL3 (*(volatile uint32_t*)0x40040960)
#define OTG_HS_DTXFSTS3 (*(volatile uint32_t*)0x40040978)
#define OTG_HS_DIEPCTL4 (*(volatile uint32_t*)0x40040980)
#define OTG_HS_DIEPCTL5 (*(volatile uint32_t*)0x400409A0)
#define OTG_HS_DIEPCTL6 (*(volatile uint32_t*)0x400409C0)
#define OTG_HS_DIEPCTL7 (*(volatile uint32_t*)0x400409E0)
#define OTG_HS_DOEPCTL0 (*(volatile uint32_t*)0x40040B00)
#define OTG_HS_DOEPCTL1 (*(volatile uint32_t*)0x40040B20)
#define OTG_HS_DOEPCTL2 (*(volatile uint32_t*)0x40040B40)
#define OTG_HS_DOEPCTL3 (*(volatile uint32_t*)0x40040B60)
#define OTG_HS_DIEPINT0 (*(volatile uint32_t*)0x40040908)
#define OTG_HS_DIEPINT1 (*(volatile uint32_t*)0x40040928)
#define OTG_HS_DIEPINT2 (*(volatile uint32_t*)0x40040948)
#define OTG_HS_DIEPINT3 (*(volatile uint32_t*)0x40040968)
#define OTG_HS_DIEPINT4 (*(volatile uint32_t*)0x40040988)
#define OTG_HS_DIEPINT5 (*(volatile uint32_t*)0x400409A8)
#define OTG_HS_DIEPINT6 (*(volatile uint32_t*)0x400409C8)
#define OTG_HS_DIEPINT7 (*(volatile uint32_t*)0x400409E8)
#define OTG_HS_DOEPINT0 (*(volatile uint32_t*)0x40040B08)
#define OTG_HS_DOEPINT1 (*(volatile uint32_t*)0x40040B28)
#define OTG_HS_DOEPINT2 (*(volatile uint32_t*)0x40040B48)
#define OTG_HS_DOEPINT3 (*(volatile uint32_t*)0x40040B68)
#define OTG_HS_DOEPINT4 (*(volatile uint32_t*)0x40040B88)
#define OTG_HS_DOEPINT5 (*(volatile uint32_t*)0x40040BA8)
#define OTG_HS_DOEPINT6 (*(volatile uint32_t*)0x40040BC8)
#define OTG_HS_DOEPINT7 (*(volatile uint32_t*)0x40040BE8)
#define OTG_HS_DIEPTSIZ0 (*(volatile uint32_t*)0x40040910)
#define OTG_HS_DIEPDMA0 (*(volatile uint32_t*)0x40040914)
#define OTG_HS_DIEPDMAB0 (*(volatile uint32_t*)0x4004091C)
#define OTG_HS_DIEPTSIZ1 (*(volatile uint32_t*)0x40040930)
#define OTG_HS_DIEPDMA1 (*(volatile uint32_t*)0x40040934)
#define OTG_HS_DIEPDMAB1 (*(volatile uint32_t*)0x4004093C)
#define OTG_HS_DIEPTSIZ2 (*(volatile uint32_t*)0x40040950)
#define OTG_HS_DIEPDMA2 (*(volatile uint32_t*)0x40040954)
#define OTG_HS_DIEPDMAB2 (*(volatile uint32_t*)0x4004095C)
#define OTG_HS_DIEPTSIZ3 (*(volatile uint32_t*)0x40040970)
#define OTG_HS_DIEPDMA3 (*(volatile uint32_t*)0x40040974)
#define OTG_HS_DIEPDMAB3 (*(volatile uint32_t*)0x4004097C)
#define OTG_HS_DOEPTSIZ0 (*(volatile uint32_t*)0x40040B10)
#define OTG_HS_DOEPDMA0 (*(volatile uint32_t*)0x40040B14)
#define OTG_HS_DOEPDMAB0 (*(volatile uint32_t*)0x40040B1C)
#define OTG_HS_DOEPTSIZ1 (*(volatile uint32_t*)0x40040B30)
#define OTG_HS_DOEPDMA1 (*(volatile uint32_t*)0x40040B34)
#define OTG_HS_DOEPDMAB1 (*(volatile uint32_t*)0x40040B3C)
#define OTG_HS_DOEPTSIZ2 (*(volatile uint32_t*)0x40040B50)
#define OTG_HS_DOEPDMA2 (*(volatile uint32_t*)0x40040B54)
#define OTG_HS_DOEPDMAB2 (*(volatile uint32_t*)0x40040B5C)
#define OTG_HS_DOEPTSIZ3 (*(volatile uint32_t*)0x40040B70)
#define OTG_HS_DOEPDMA3 (*(volatile uint32_t*)0x40040B74)
#define OTG_HS_DOEPDMAB3 (*(volatile uint32_t*)0x40040B7C)
#define OTG_HS_PCGCCTL (*(volatile uint32_t*)0x40040E00)
#define ETH_MACCR (*(volatile uint32_t*)0x40028000)
#define ETH_MACFFR (*(volatile uint32_t*)0x40028004)
#define ETH_MACHTHR (*(volatile uint32_t*)0x40028008)
#define ETH_MACHTLR (*(volatile uint32_t*)0x4002800C)
#define ETH_MACMIIAR (*(volatile uint32_t*)0x40028010)
#define ETH_MACMIIDR (*(volatile uint32_t*)0x40028014)
#define ETH_MACFCR (*(volatile uint32_t*)0x40028018)
#define ETH_MACVLANTR (*(volatile uint32_t*)0x4002801C)
#define ETH_MACRWUFFR (*(volatile uint32_t*)0x40028028)
#define ETH_MACPMTCSR (*(volatile uint32_t*)0x4002802C)
#define ETH_MACDBGR (*(volatile uint32_t*)0x40028034)
#define ETH_MACSR (*(volatile uint32_t*)0x40028038)
#define ETH_MACIMR (*(volatile uint32_t*)0x4002803C)
#define ETH_MACA0HR (*(volatile uint32_t*)0x40028040)
#define ETH_MACA0LR (*(volatile uint32_t*)0x40028044)
#define ETH_MACA1HR (*(volatile uint32_t*)0x40028048)
#define ETH_MACA1LR (*(volatile uint32_t*)0x4002804C)
#define ETH_MACA2HR (*(volatile uint32_t*)0x40028050)
#define ETH_MACA2LR (*(volatile uint32_t*)0x40028054)
#define ETH_MACA3HR (*(volatile uint32_t*)0x40028058)
#define ETH_MACA3LR (*(volatile uint32_t*)0x4002805C)
#define ETH_MMCCR (*(volatile uint32_t*)0x40028100)
#define ETH_MMCRIR (*(volatile uint32_t*)0x40028104)
#define ETH_MMCTIR (*(volatile uint32_t*)0x40028108)
#define ETH_MMCRIMR (*(volatile uint32_t*)0x4002810C)
#define ETH_MMCTIMR (*(volatile uint32_t*)0x40028110)
#define ETH_MMCTGFSCCR (*(volatile uint32_t*)0x4002814C)
#define ETH_MMCTGFMSCCR (*(volatile uint32_t*)0x40028150)
#define ETH_MMCTGFCR (*(volatile uint32_t*)0x40028168)
#define ETH_MMCRFCECR (*(volatile uint32_t*)0x40028194)
#define ETH_MMCRFAECR (*(volatile uint32_t*)0x40028198)
#define ETH_MMCRGUFCR (*(volatile uint32_t*)0x400281C4)
#define ETH_PTPTSCR (*(volatile uint32_t*)0x40028700)
#define ETH_PTPSSIR (*(volatile uint32_t*)0x40028704)
#define ETH_PTPTSHR (*(volatile uint32_t*)0x40028708)
#define ETH_PTPTSLR (*(volatile uint32_t*)0x4002870C)
#define ETH_PTPTSHUR (*(volatile uint32_t*)0x40028710)
#define ETH_PTPTSLUR (*(volatile uint32_t*)0x40028714)
#define ETH_PTPTSAR (*(volatile uint32_t*)0x40028718)
#define ETH_PTPTTHR (*(volatile uint32_t*)0x4002871C)
#define ETH_PTPTTLR (*(volatile uint32_t*)0x40028720)
#define ETH_PTPTSSR (*(volatile uint32_t*)0x40028728)
#define ETH_PTPPPSCR (*(volatile uint32_t*)0x4002872C)
#define ETH_DMABMR (*(volatile uint32_t*)0x40029000)
#define ETH_DMATPDR (*(volatile uint32_t*)0x40029004)
#define ETH_DMARPDR (*(volatile uint32_t*)0x40029008)
#define ETH_DMARDLAR (*(volatile uint32_t*)0x4002900C)
#define ETH_DMATDLAR (*(volatile uint32_t*)0x40029010)
#define ETH_DMASR (*(volatile uint32_t*)0x40029014)
#define ETH_DMAOMR (*(volatile uint32_t*)0x40029018)
#define ETH_DMAIER (*(volatile uint32_t*)0x4002901C)
#define ETH_DMAMFBOCR (*(volatile uint32_t*)0x40029020)
#define ETH_DMARSWTR (*(volatile uint32_t*)0x40029024)
#define ETH_DMACHTDR (*(volatile uint32_t*)0x40029048)
#define ETH_DMACHRDR (*(volatile uint32_t*)0x4002904C)
#define ETH_DMACHTBAR (*(volatile uint32_t*)0x40029050)
#define ETH_DMACHRBAR (*(volatile uint32_t*)0x40029054)
#define FSMC_BCR1 (*(volatile uint32_t*)0xA0000000)
#define FSMC_BTR1 (*(volatile uint32_t*)0xA0000004)
#define FSMC_BCR2 (*(volatile uint32_t*)0xA0000008)
#define FSMC_BTR2 (*(volatile uint32_t*)0xA000000C)
#define FSMC_BCR3 (*(volatile uint32_t*)0xA0000010)
#define FSMC_BTR3 (*(volatile uint32_t*)0xA0000014)
#define FSMC_BCR4 (*(volatile uint32_t*)0xA0000018)
#define FSMC_BTR4 (*(volatile uint32_t*)0xA000001C)
#define FSMC_PCR2 (*(volatile uint32_t*)0xA0000060)
#define FSMC_SR2 (*(volatile uint32_t*)0xA0000064)
#define FSMC_PMEM2 (*(volatile uint32_t*)0xA0000068)
#define FSMC_PATT2 (*(volatile uint32_t*)0xA000006C)
#define FSMC_ECCR2 (*(volatile uint32_t*)0xA0000074)
#define FSMC_PCR3 (*(volatile uint32_t*)0xA0000080)
#define FSMC_SR3 (*(volatile uint32_t*)0xA0000084)
#define FSMC_PMEM3 (*(volatile uint32_t*)0xA0000088)
#define FSMC_PATT3 (*(volatile uint32_t*)0xA000008C)
#define FSMC_ECCR3 (*(volatile uint32_t*)0xA0000094)
#define FSMC_PCR4 (*(volatile uint32_t*)0xA00000A0)
#define FSMC_SR4 (*(volatile uint32_t*)0xA00000A4)
#define FSMC_PMEM4 (*(volatile uint32_t*)0xA00000A8)
#define FSMC_PATT4 (*(volatile uint32_t*)0xA00000AC)
#define FSMC_PIO4 (*(volatile uint32_t*)0xA00000B0)
#define FSMC_BWTR1 (*(volatile uint32_t*)0xA0000104)
#define FSMC_BWTR2 (*(volatile uint32_t*)0xA000010C)
#define FSMC_BWTR3 (*(volatile uint32_t*)0xA0000114)
#define FSMC_BWTR4 (*(volatile uint32_t*)0xA000011C)

#define CPACR (*(volatile uint32_t*)0xE000ED88)

#endif
