#include "FreeRTOS.h"
#include "task.h"
#include "stm32f407.h"
#include "vic.h"

uint8_t ucHeap[configTOTAL_HEAP_SIZE];

void init(void * pvParameters)
{
  for(;;)
  {
    vTaskDelay(100);
  }
}

int main(void)
{
  vic_init();

  xTaskCreate(init, "init", configMINIMAL_STACK_SIZE, NULL, 2, NULL);

  vTaskStartScheduler();
  return 0;
}


void vApplicationStackOverflowHook( TaskHandle_t xTask,
                                               char * pcTaskName )
{
  /* This will get called if a stack overflow is detected during the context
     switch.  Set configCHECKFORSTACKOVERFLOWS to 2 to also check for stack
     problems within nested interrupts, but only do this for debug purposes as
     it will increase the context switch time. /
  (void)pxTask;
  (void)pcTaskName;
  taskDISABLE_INTERRUPTS();
  / Write your code here … */
  asm volatile ("bkpt #0");
}

void vApplicationIdleHook(void)
{
  static int i = 0;
  i++;
}

void vApplicationTickHook(void)
{
  static int tick = 0;
  tick++;
}
